
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>

#define STEPPER_SCALE_0  26.6667
#define STEPPER_SCALE_1  26.6667
#define STEPPER_SCALE_2  13.7174
#define STEPPER_SCALE_3  12.0680
#define STEPPER_SCALE_4  2.0
#define STEPPER_SCALE_5  2.0

int demo = 0;

#include "serial.c"

int tool_active = 1;
int tool_offset_x[10];
int tool_offset_y[10];
int tool_offset_z[10];
int tool_offset_a[10];
int tool_offset_w[10];
float tool_offset_s[10];
int last_tool_offset_z = -100000;

int x_offset = 3500;
int y_offset = 6500;
int z_offset = 0;
int z_stop = 1050;
int z_start = 900;
int speed_z = 255;

int last_updown = 0;
int cnc_pen(int updown) {
	char cmd[256];
	if (last_updown != updown) {
		if (updown == 3) {
			sprintf(cmd, "A%i=%i\n", tool_offset_a[tool_active], z_offset);
			serial_send(cmd);
			last_updown = updown;
		} else if (updown == 2) {
			sprintf(cmd, "A%i=%i\n", tool_offset_a[tool_active], (int)((float)(z_stop + tool_offset_z[tool_active]) * tool_offset_s[tool_active]) + z_offset);
			serial_send(cmd);
			sleep(3);
			sprintf(cmd, "A%i=%i\n", tool_offset_a[tool_active], (int)((float)(z_start + tool_offset_z[tool_active]) * tool_offset_s[tool_active]) + z_offset);
			serial_send(cmd);
			last_updown = 1;
		} else if (updown == 1) {
			cnc_speed(255);
			sprintf(cmd, "A%i=%i\n", tool_offset_a[tool_active], (int)((float)(z_start + tool_offset_z[tool_active]) * tool_offset_s[tool_active]) + z_offset);
			serial_send(cmd);
			cnc_speed(speed_z);
			sprintf(cmd, "A%i=%i\n", tool_offset_a[tool_active], (int)((float)(z_stop + tool_offset_z[tool_active]) * tool_offset_s[tool_active]) + z_offset);
			serial_send(cmd);
			last_updown = updown;
		} else if (updown == 0) {
			cnc_speed(255);
			sprintf(cmd, "A%i=%i\n", tool_offset_a[tool_active], (int)((float)(z_start + tool_offset_z[tool_active]) * tool_offset_s[tool_active]) + z_offset);
			serial_send(cmd);
			last_updown = updown;
		}
	}
	return 0;
}

int cnc_speed(int x, int y) {
/*	char cmd[256];
	sprintf(cmd, "A0=%i,1=%i\n", (int)((float)(x + tool_offset_x[tool_active]) * STEPPER_SCALE_0) + x_offset, (int)((float)(y + tool_offset_y[tool_active]) * STEPPER_SCALE_1 ) + y_offset);
	serial_send(cmd);*/
	return 0;
}

int cnc_pos(int x, int y) {
	char cmd[256];
	sprintf(cmd, "A0=%i,1=%i\n", (int)((float)(x + tool_offset_x[tool_active]) * STEPPER_SCALE_0) + x_offset, (int)((float)(y + tool_offset_y[tool_active]) * STEPPER_SCALE_1 ) + y_offset);
	serial_send(cmd);
	return 0;
}

int cnc_pos_null(int x, int y) {
	char cmd[256];
	sprintf(cmd, "A0=%i,1=%i\n", (int)((float)(x + tool_offset_x[tool_active]) * STEPPER_SCALE_0), (int)((float)(y + tool_offset_y[tool_active]) * STEPPER_SCALE_1));
	serial_send(cmd);
	return 0;
}

int main(int argc, char *argv[]) {
	char tmp_str[256];
	char tmp_str2[256];

	tool_offset_x[0] = 0;		// X-Diff in mm/10
	tool_offset_y[0] = 630;		// Y-Diff in mm/10
	tool_offset_z[0] = 0;		// Z-Diff in mm/10
	tool_offset_a[0] = 2;		// Achsen-Nummer
	tool_offset_s[0] = 13.7174;	// Achsen-Scale (Stepps/0.1mm)
	tool_offset_w[0] = 3;		// Wartezeit nach Motor-On in secunden
	tool_offset_x[1] = 0;
	tool_offset_y[1] = 0;
	tool_offset_z[1] = 0;
	tool_offset_a[1] = 5;
	tool_offset_s[1] = 2.0;
	tool_offset_w[1] = 0;
	tool_active = 1;

	if (serial_open() == 0) {
		if (argc == 1) {
		} else if (argc == 2 && strcmp(argv[1] , "-o") == 0) {
			serial_send("O\n");
		} else if (argc == 2 && strcmp(argv[1] , "-r") == 0) {
			serial_send("R5\n");
			serial_send("R4\n");
			serial_send("R2\n");
			serial_send("R1\n");
			serial_send("R0\n");
			serial_send("O\n");
		} else if (argc == 2 && strcmp(argv[1] , "-w") == 0) {
			tmp_str2[0] = 0;
			serial_send("R5\n");
			serial_send("R4\n");
			serial_send("R2\n");
			serial_send("R1\n");
// 			serial_send("R0\n");
			tool_active = 1;
			sprintf(tmp_str, "A1=%i\n", (int)((float)(tool_offset_y[tool_active]) * STEPPER_SCALE_1));
			serial_send(tmp_str);
			sprintf(tmp_str, "W%i\n", tool_offset_a[tool_active]);
			serial_send_receive(tmp_str, tmp_str2);
			fprintf(stderr, "REP: %0.2f mm\n", (float)(atoi(tmp_str2)) / tool_offset_s[tool_active] / 10.0);
			tool_active = 0;
			sprintf(tmp_str, "A1=%i\n", (int)((float)(tool_offset_y[tool_active]) * STEPPER_SCALE_1));
			serial_send(tmp_str);
			sprintf(tmp_str, "W%i\n", tool_offset_a[tool_active]);
			serial_send_receive(tmp_str, tmp_str2);
			fprintf(stderr, "REP: %0.2f mm\n", (float)(atoi(tmp_str2)) / tool_offset_s[tool_active] / 10.0);
		} else {
			sprintf(tmp_str, "%s\n", argv[1]);
			serial_send_receive(tmp_str, tmp_str2);
			fprintf(stderr, "REP: %s\n", tmp_str2);
		}
	} else {
		fprintf(stderr, "Error while opening the Serial-Port\n");
		exit(1);
	}
	serial_close();
	exit(0);
	return 0;
}




