
#include "vcad.h"
#include "vcad_line.c"
#include "vcad_box.c"
#include "vcad_recgard.c"
#include "vcad_circgard.c"
#include "vcad_reccirc.c"
#include "vcad_circle.c"
#include "vcad_text.c"

int vcad_file_add_lib(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int vcad_id = vcad_get_free_id();
	if ((stream = fopen(filename, "r")) != 0) {
		while(fread(&ECAD[vcad_id], sizeof(Ecad_Element), 1, stream) != 0) {
			ECAD[vcad_id].x1 += (5.0 * vcad_raster);
			ECAD[vcad_id].y1 += (5.0 * vcad_raster);
			ECAD[vcad_id].x2 += (5.0 * vcad_raster);
			ECAD[vcad_id].y2 += (5.0 * vcad_raster);
			ECAD[vcad_id].group = vcad_group_id;
			vcad_id = vcad_get_free_id();
                }
		fclose(stream);
	}
	vcad_group_id++;
	vcad_active_id = vcad_get_free_id();
	return 0;
}

int vcad_hpgl_last_x = 0;
int vcad_hpgl_last_y = 0;
int vcad_hpgl_pen_z = 0;

int vcad_hpgl2vcad(char *hpgl_cmd) {
	int vcad_id = vcad_get_free_id();
	char *loc;
	int x = 0;
	int y = 0;
	vcad_id = vcad_get_free_id();
	if (hpgl_cmd[0] == 'I') {
		if (hpgl_cmd[1] == 'N') {
		} else if (hpgl_cmd[1] == 'W') {
		}
	} else if (hpgl_cmd[0] == 'P') {
		if (hpgl_cmd[1] == 'A') {
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = atoi(hpgl_cmd + 2) / 4 * 10;
				y = atoi(loc + 1) / 4 * 10;
				if (vcad_hpgl_pen_z == 1) {
					vcad_active_id = vcad_get_free_id();
					vcad_set_color(vcad_active_id);
					vcad_set_line(1, 0, vcad_hpgl_last_x, vcad_hpgl_last_y, x, y, vcad_linesize);
				}
				vcad_hpgl_last_x = x;
				vcad_hpgl_last_y = y;
			}
		} else if (hpgl_cmd[1] == 'R') {
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = vcad_hpgl_last_x + (atoi(hpgl_cmd + 2) / 4 * 10);
				y = vcad_hpgl_last_y + (atoi(loc + 1) / 4 * 10);
				if (vcad_hpgl_pen_z == 1) {
					vcad_active_id = vcad_get_free_id();
					vcad_set_color(vcad_active_id);
					vcad_set_line(1, 0, vcad_hpgl_last_x, vcad_hpgl_last_y, x, y, vcad_linesize);
				}
				vcad_hpgl_last_x = x;
				vcad_hpgl_last_y = y;
			}
		} else if (hpgl_cmd[1] == 'U') {
			vcad_hpgl_pen_z = 0;
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = vcad_hpgl_last_x + (atoi(hpgl_cmd + 2) / 4 * 10);
				y = vcad_hpgl_last_y + (atoi(loc + 1) / 4 * 10);
				vcad_hpgl_last_x = x;
				vcad_hpgl_last_y = y;
			}
		} else if (hpgl_cmd[1] == 'D') {
			vcad_hpgl_pen_z = 1;
			if ((loc = strstr(hpgl_cmd + 2, "x")) != 0 || (loc = strstr(hpgl_cmd + 2, " ")) != 0 || (loc = strstr(hpgl_cmd + 2, ",")) != 0) {
				x = vcad_hpgl_last_x + (atoi(hpgl_cmd + 2) / 4 * 10);
				y = vcad_hpgl_last_y + (atoi(loc + 1) / 4 * 10);
				vcad_active_id = vcad_get_free_id();
				vcad_set_color(vcad_active_id);
				vcad_set_line(1, 0, vcad_hpgl_last_x, vcad_hpgl_last_y, x, y, vcad_linesize);
				vcad_hpgl_last_x = x;
				vcad_hpgl_last_y = y;
			}
		}
	} else if (hpgl_cmd[0] == 'S') {
		if (hpgl_cmd[1] == 'P') {
		}
	}
	ECAD[vcad_id].group = vcad_group_id;
	return 0;
}

int vcad_file_add_hpgl(char *filename) {
	FILE *stream;
	char tmp_str[512];
	char tmp_char;
	int n = 0;
	tmp_str[0] = 0;
	n = 0;
	if ((stream = fopen(filename, "r")) != 0) {
		while(fread(&tmp_char, 1, 1, stream) != 0) {
			if (tmp_char == '\n' || tmp_char == ';') {
				tmp_str[n] = 0;
				vcad_hpgl2vcad(tmp_str);
				tmp_str[0] = 0;
				n = 0;
			} else {
				tmp_str[n++] = tmp_char;
			}
		}
		vcad_hpgl2vcad(tmp_str);
		fclose(stream);
	}
	vcad_group_id++;
	return 0;
}


int vcad_file_add_dxf(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int n = 0;
	int mode = 0;
	int x[10];
	int y[10];
	int z[10];
	int l = 0;
	int c = 0;
	int rc = 0;
	tmp_str[0] = 0;
	if ((stream = fopen(filename, "r")) != 0) {
		while(!feof(stream)) {
			fgets(tmp_str, 512, stream);
			n = 0;
			while (tmp_str[n] == ' ') {
				n++;
			}
			if (tmp_str[n] - 48 == 0) {
				if (mode == 1) {
// 					fprintf(stderr, "Line(%i): %i,%i,%i -> %i,%i,%i\n", rc++, x[0], y[0], z[0], x[1], y[1], z[1]);
					vcad_active_id = vcad_get_free_id();
					vcad_set_color(vcad_active_id);
					vcad_set_line(1, 0, x[0], y[0], x[1], y[1], vcad_linesize);
				}
				fgets(tmp_str, 512, stream);
				if (strcmp(tmp_str, "SECTION\n") == 0) {
					mode = 0;
				} else if (strcmp(tmp_str, "LINE\n") == 0 || strcmp(tmp_str, "3DLINE\n") == 0) {
					mode = 1;
				} else if (strcmp(tmp_str, "CIRCLE\n") == 0) {
					mode = 2;
				} else if (strcmp(tmp_str, "3DFACE\n") == 0) {
					mode = 3;
				} else if (strcmp(tmp_str, "ENDSEC\n") == 0) {
					mode = 0;
				} else if (strcmp(tmp_str, "EOF\n") == 0) {
					mode = 0;
				}
			} else if (tmp_str[n] - 48 == 8) {
				fgets(tmp_str, 512, stream);
				l = atoi(tmp_str);
			} else if (mode == 1 && tmp_str[n] - 48 == 1) {
				c = tmp_str[n + 1] - 48;
				fgets(tmp_str, 512, stream);
				x[c] = (int)(atof(tmp_str) * 100.0);
			} else if (mode == 1 && tmp_str[n] - 48 == 2) {
				c = tmp_str[n + 1] - 48;
				fgets(tmp_str, 512, stream);
				y[c] = (int)(atof(tmp_str) * 100.0);
			} else if (mode == 1 && tmp_str[n] - 48 == 3) {
				c = tmp_str[n + 1] - 48;
				fgets(tmp_str, 512, stream);
				z[c] = (int)(atof(tmp_str) * 100.0);
			}
		}
		fclose(stream);
	}
	vcad_group_id++;
	return 0;
}

int vcad_zoom_x(int value) {
	return (int)((float)value * vcad_zoom) + vcad_offset_x;
}

int vcad_unzoom_x(int value) {
	return (int)((float)(value - vcad_offset_x) / vcad_zoom);
}

int vcad_zoom_y(int value) {
	return Widget[WidgetID[EXPORT_IMAGE]].h - ((int)((float)value * vcad_zoom) + vcad_offset_y);
}

int vcad_unzoom_y(int value) {
	return (int)((float)((Widget[WidgetID[EXPORT_IMAGE]].h - value) - vcad_offset_y) / vcad_zoom);
}

int vcad_unzoom_int(int value) {
	return (int)((float)value / vcad_zoom);
}

int vcad_zoom_int(int value) {
	return (int)((float)value * vcad_zoom);
}

int vcad_clean_select(void) {
	ECAD[vcad_active_id].type = 0;
	ECAD[vcad_active_id].x1 = 0;
	ECAD[vcad_active_id].y1 = 0;
	ECAD[vcad_active_id].z1 = 0;
	ECAD[vcad_active_id].x2 = 0;
	ECAD[vcad_active_id].y2 = 0;
	ECAD[vcad_active_id].z2 = 0;
	ECAD[vcad_active_id].size = 0;
	ECAD[vcad_active_id].dtype = 0;
	ECAD[vcad_active_id].rotate = 0;
	ECAD[vcad_active_id].mode = 0;
	ECAD[vcad_active_id].view = 0;
	ECAD[vcad_active_id].layer = 0;
	ECAD[vcad_active_id].selected = 0;
	ECAD[vcad_active_id].text[0] = 0;
	ECAD[vcad_active_id].info[0] = 0;
	vcad_select = 0;
	return 0;
}

int vcad_file_load(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int vcad_id = 0;
	if ((stream = fopen(filename, "r")) != 0) {
		vcad_init();
		strcpy(vcad_filename, filename);
		while(fread(&ECAD[vcad_id], sizeof(Ecad_Element), 1, stream) != 0) {
			vcad_id++;
                }
		vcad_active_id = vcad_get_free_id();
		fclose(stream);
	}
	return 0;
}

int vcad_file_save(char *filename) {
	FILE *stream;
	char tmp_str[512];
	int vcad_id = 0;
	if ((stream = fopen(filename, "w")) != 0) {
		vcad_select_delete();
		vcad_clean_select();
		for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
			if (ECAD[vcad_id].view != 0) {
				fwrite(&ECAD[vcad_id], sizeof(Ecad_Element), 1, stream);
			}
		}
		fclose(stream);
	}
	return 0;
}

int vcad_get_free_id(void) {
	int vcad_id = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].type == 0) {
			return vcad_id;
		}
	}
	return -1;
}

int vcad_toggle_show_top_label(void) {
	vcad_show_top_label = 1 - vcad_show_top_label;
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].action = vcad_show_top_label + 1;
	return 0;
}

int vcad_toggle_show_bottom_cu(void) {
	vcad_show_bottom_cu = 1 - vcad_show_bottom_cu;
	Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].action = vcad_show_bottom_cu + 1;
	return 0;
}

int vcad_toggle_show_drill(void) {
	vcad_show_drill = 1 - vcad_show_drill;
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].action = vcad_show_drill + 1;
	return 0;
}

int vcad_set_color(int vcad_id) {
	bc_r = 8;
	bc_g = 120;
	bc_b = 5;
	bc_a = 255;
	tl_r = 255;
	tl_g = 255;
	tl_b = 255;
	tl_a = 255;
	d_r = 255;
	d_g = 20;
	d_b = 20;
	d_a = 255;
	if (vcad_export != 0) {
		bc_r = 0;
		bc_g = 0;
		bc_b = 0;
		bc_a = 255;
		tl_r = 0;
		tl_g = 0;
		tl_b = 0;
		tl_a = 255;
		d_r = 0;
		d_g = 0;
		d_b = 0;
		d_a = 255;
	} else if (vcad_mouse_mode == M_SELECT && ECAD[vcad_id].selected == 1) {
		bc_r = 255;
		bc_g = 0;
		bc_b = 0;
		bc_a = 255;
		tl_r = 255;
		tl_g = 0;
		tl_b = 0;
		tl_a = 255;
		d_r = 255;
		d_g = 0;
		d_b = 0;
		d_a = 255;
	} else if (ECAD[vcad_id].mode == 0) {
		bc_r = 128;
		bc_g = 128;
		bc_b = 128;
		bc_a = 128;
		tl_r = 128;
		tl_g = 128;
		tl_b = 128;
		tl_a = 128;
		d_r = 128;
		d_g = 128;
		d_b = 128;
		d_a = 128;
	}
	return 0;
}

int vcad_size_x(void) {
	int vcad_id = 0;
	int x = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
/*			if (x < vcad_zoom_x(ECAD[vcad_id].x2)) {
				x = vcad_zoom_x(ECAD[vcad_id].x2);
			}*/
			if (x < ECAD[vcad_id].x2) {
				x = ECAD[vcad_id].x2;
			}
		}
	}
	return x;
}

int vcad_size_y(void) {
	int vcad_id = 0;
	int y = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
/*			if (y < vcad_zoom_y(ECAD[vcad_id].y2)) {
				y = vcad_zoom_y(ECAD[vcad_id].y2);
			}*/
			if (y < ECAD[vcad_id].y2) {
				y = ECAD[vcad_id].y2;
			}
		}
	}
	return y;
}

int vcad_minsize_x(void) {
	int vcad_id = 0;
	int x = vcad_size_x();
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
			if (x > ECAD[vcad_id].x1) {
				x = ECAD[vcad_id].x1;
			}
		}
	}
	return x;
}

int vcad_minsize_y(void) {
	int vcad_id = 0;
	int y = vcad_size_y();
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
			if (y > ECAD[vcad_id].y1) {
				y = ECAD[vcad_id].y1;
			}
		}
	}
	return y;
}

GLuint gl_3d_export_quads(SDL_Surface *Surface, int diff) {
	int test_x = 0;
	int test_y = 0;
	int test2_z = 0;
	int last_x = 0;
	int last_y = 0;
	int last_z = 0;
	float alpha = 1.0;
        float color[8][4]= {{ 1.0,  1.0,  0.0,  alpha},
			    { 1.0,  0.0,  0.0,  alpha},
			    { 0.0,  0.0,  0.0,  alpha},
			    { 0.0,  1.0,  0.0,  alpha},
			    { 0.9,  0.9,  0.9,  alpha},
			    { 1.0,  1.0,  1.0,  alpha},
			    { 1.0,  0.0,  1.0,  alpha},
			    { 0.8,  0.8,  0.8,  alpha}};

	for (test_y = 0; test_y < Surface->h; test_y += diff) {
		last_x = 0;
		last_y = test_y;
		last_z = 255;
		for (test_x = 0; test_x < Surface->w; test_x += 1) {
			test2_z = (int)(sdl_getpixel(Surface, test_x, Surface->h - 1 - test_y) & 255);
			if (last_z != test2_z) {
				if (last_z != 255){
					if (vcad_raster_view == 0) {
						glBegin(GL_QUADS);
					} else {
						glBegin(GL_LINES);
					}
					glColor4fv(color[7]);
					glTexCoord2f(0, 0);
					glVertex3f(last_x, last_y, (last_z * -1 + 255));
					glTexCoord2f(1, 0);
					glVertex3f(test_x, last_y, (last_z * -1 + 255));
					if (vcad_raster_view == 0) {
						glTexCoord2f(1, 1);
						glVertex3f(test_x, last_y + diff + 0, (last_z * -1 + 255));
						glTexCoord2f(0, 1);
						glVertex3f(last_x, last_y + diff + 0, (last_z * -1 + 255));
						glTexCoord2f(0, 0);
						glVertex3f(last_x, last_y, 0);
						glTexCoord2f(1, 0);
						glVertex3f(test_x, last_y, 0);
						glTexCoord2f(1, 1);
						glVertex3f(test_x, last_y + diff + 0, 0);
						glTexCoord2f(0, 1);
						glVertex3f(last_x, last_y + diff + 0, 0);
					}
					glEnd();
				}
				if (vcad_raster_view == 0) {
					glBegin(GL_QUADS);
				} else {
					glBegin(GL_LINES);
				}
				glColor4fv(color[4]);
				glTexCoord2f(0, 0);
				glVertex3f(test_x, test_y, (last_z * -1 + 255));
				glTexCoord2f(1, 0);
				glVertex3f(test_x, test_y, (test2_z * -1 + 255));
				if (vcad_raster_view == 0) {
					glTexCoord2f(1, 1);
					glVertex3f(test_x, test_y + diff + 0, (test2_z * -1 + 255));
					glTexCoord2f(0, 1);
					glVertex3f(test_x, test_y + diff + 0, (last_z * -1 + 255));
				}
				glEnd();
				last_x = test_x;
				last_y = test_y;
			}
			last_z = test2_z;
		}
		if (last_z != 255){
			if (vcad_raster_view == 0) {
				glBegin(GL_QUADS);
			} else {
				glBegin(GL_LINES);
			}
			glColor4fv(color[7]);
			glTexCoord2f(0, 0);
			glVertex3f(last_x, last_y, (last_z * -1 + 255));
			glTexCoord2f(1, 0);
			glVertex3f(test_x, last_y, (last_z * -1 + 255));
			if (vcad_raster_view == 0) {
				glTexCoord2f(1, 1);
				glVertex3f(test_x, last_y + diff + 0, (last_z * -1 + 255));
				glTexCoord2f(0, 1);
				glVertex3f(last_x, last_y + diff + 0, (last_z * -1 + 255));
				glTexCoord2f(0, 0);
				glVertex3f(last_x, last_y, 0);
				glTexCoord2f(1, 0);
				glVertex3f(test_x, last_y, 0);
				glTexCoord2f(1, 1);
				glVertex3f(test_x, last_y + diff + 0, 0);
				glTexCoord2f(0, 1);
				glVertex3f(last_x, last_y + diff + 0, 0);
			}
			glEnd();
		}
		if (vcad_raster_view == 0) {
			glBegin(GL_QUADS);
		} else {
			glBegin(GL_LINES);
		}
		glColor4fv(color[4]);
		glTexCoord2f(0, 0);
		glVertex3f(test_x, test_y, 0);
		glTexCoord2f(1, 0);
		glVertex3f(test_x, test_y, (test2_z * -1 + 255));
		if (vcad_raster_view == 0) {
			glTexCoord2f(1, 1);
			glVertex3f(test_x, test_y + diff + 0, (test2_z * -1 + 255));
			glTexCoord2f(0, 1);
			glVertex3f(test_x, test_y + diff + 0, 0);
		}
		glEnd();
	}

	for (test_x = 0; test_x <= Surface->w - 100; test_x += diff) {
		last_x = test_x;
		last_y = 0;
		last_z = 255;
		for (test_y = 0; test_y < Surface->h - 100; test_y += 1) {
			test2_z = (int)(sdl_getpixel(Surface, test_x, Surface->h - 1 - test_y) & 255);
			if (last_z != test2_z) {
				if (vcad_raster_view == 0) {
					glBegin(GL_QUADS);
				} else {
					glBegin(GL_LINES);
				}
				glColor4fv(color[4]);
				glTexCoord2f(0, 0);
				glVertex3f(test_x, test_y, (last_z * -1 + 255));
				glTexCoord2f(1, 0);
				glVertex3f(test_x, test_y, (test2_z * -1 + 255));
				glTexCoord2f(1, 1);
				glVertex3f(test_x + diff + 0, test_y, (test2_z * -1 + 255));
				glTexCoord2f(0, 1);
				glVertex3f(test_x + diff + 0, test_y, (last_z * -1 + 255));
				glEnd();
				last_x = test_x;
				last_y = test_y;
			}
			last_z = test2_z;
		}
		if (vcad_raster_view == 0) {
			glBegin(GL_QUADS);
		} else {
			glBegin(GL_LINES);
		}
		glColor4fv(color[4]);
		glTexCoord2f(0, 0);
		glVertex3f(test_x, test_y, 0);
		glTexCoord2f(1, 0);
		glVertex3f(test_x, test_y, (test2_z * -1 + 255));
		glTexCoord2f(1, 1);
		glVertex3f(test_x + diff + 0, test_y, (test2_z * -1 + 255));
		glTexCoord2f(0, 1);
		glVertex3f(test_x + diff + 0, test_y, 0);
		glEnd();
	}
	return 0;
}

int vcad_check_z_circle(SDL_Surface *Surface, int x, int y, int size) {
	int px = 0;
	int py = 0;
	int n_s = 0;
	int return_z = 255;
	float winkel = 0;
	float FAK = 2 * 3.141592653589793 / 360.0;
	Uint32 RGBA_255_255_255 = SDL_MapRGB(Surface->format, 255, 255, 255);
	for (n_s = size; return_z > 0 && n_s >= 1; n_s--) {
		for(winkel = 0; return_z > 0 && winkel <= 45; winkel += 1) {
			px = (int)(n_s * cos(FAK * winkel));
			py = (int)(n_s * sin(FAK * winkel));
			if (x - px < 0 || y - py < 0 || x + px >= Surface->w || y + py >= Surface->h) {
				continue;
			}
			if (x - py < 0 || y - px < 0 || x + py >= Surface->w || y + px >= Surface->h) {
				continue;
			}
			if ((sdl_getpixel(Surface, x + px, y + py) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x + px, y + py) & 255);
			}
			if ((sdl_getpixel(Surface, x + py, y + px) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x + py, y + px) & 255);
			}
			if ((sdl_getpixel(Surface, x - px, y - py) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x - px, y - py) & 255);
			}
			if ((sdl_getpixel(Surface, x - py, y - px) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x - py, y - px) & 255);
			}
			if ((sdl_getpixel(Surface, x - px, y + py) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x - px, y + py) & 255);
			}
			if ((sdl_getpixel(Surface, x - py, y + px) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x - py, y + px) & 255);
			}
			if ((sdl_getpixel(Surface, x + px, y - py) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x + px, y - py) & 255);
			}
			if ((sdl_getpixel(Surface, x + py, y - px) & 255) < return_z) {
				return_z = (sdl_getpixel(Surface, x + py, y - px) & 255);
			}
		}
	}
        return return_z;
}

int gl_3d_export_cnc(SDL_Surface *Surface, int diff_x, int diff_y) {
	int test_x = 0;
	int test_y = 0;
	int test_z = 0;
	int max_z = 0;
	int sx = vcad_zoom_x(vcad_size_x());
	int sy = vcad_zoom_y(vcad_size_y());
	int mx = vcad_zoom_x(vcad_minsize_x());
	int my = vcad_zoom_y(vcad_minsize_y());
	cnc_start(sx, sy);
	cnc_soft_start(1);
	cnc_go_z(0);
	cnc_go_xy(mx, my);
	cnc_soft_start(0);
	cnc_drill_set_speed(25);
	for (max_z = 100; cnc_active == 1 && max_z < 255; max_z += (255 / 6)) {
		for (test_y = my; cnc_active == 1 && test_y <= sy; test_y += diff_y) {
			for (test_x = mx; test_x <= sx; test_x += diff_x) {
				test_z = vcad_check_z_circle(Surface, test_x, test_y, ZAxis[cnc_tool_active].tool.head.radius);
				if (test_z > max_z) {
					test_z = max_z;
				}
				cnc_go_xyz(test_x, test_y, ZAxis[cnc_tool_active].offset_z - ((255 - test_z)));
			}
			test_x = sx;
			test_z = vcad_check_z_circle(Surface, test_x, test_y, ZAxis[cnc_tool_active].tool.head.radius);
			if (test_z > max_z) {
				test_z = max_z;
			}
			cnc_go_xyz(test_x, test_y, ZAxis[cnc_tool_active].offset_z - ((255 - test_z)));
			gui_check();
			cnc_active = gui_running;
			gui_running = 1;
			gui_draw();
			if (cnc_active == 1 && test_y <= sy) {
				test_y += diff_y;
				for (; test_x >= mx; test_x -= diff_x) {
					test_z = vcad_check_z_circle(Surface, test_x, test_y, ZAxis[cnc_tool_active].tool.head.radius);
					if (test_z > max_z) {
						test_z = max_z;
					}
					cnc_go_xyz(test_x, test_y, ZAxis[cnc_tool_active].offset_z - ((255 - test_z)));
				}
				test_x = mx;
				test_z = vcad_check_z_circle(Surface, test_x, test_y, ZAxis[cnc_tool_active].tool.head.radius);
				if (test_z > max_z) {
					test_z = max_z;
				}
				cnc_go_xyz(test_x, test_y, ZAxis[cnc_tool_active].offset_z - ((255 - test_z)));
				gui_check();
				cnc_active = gui_running;
				gui_running = 1;
				gui_draw();
		}
		}
		cnc_go_z(0);
		cnc_go_xy(mx, my);
	}
	cnc_stop();
	return 0;
}

int vcad_3d_out(void) {
	int review_raster = 0;
	vcad_select_delete();
	vcad_mouse_mode = M_NONE;
	vcad_clean_select();
	vcad_zoom = 1.0;
	if (vcad_raster_view == 1) {
		review_raster = 1;
		vcad_raster_view = 0;
	}
	fprintf(stderr, "1:1 Image-Size: %ix%i\n", vcad_size_x(), vcad_size_y());
	ECAD_Surface = SDL_CreateRGBSurface(SDL_SWSURFACE, vcad_size_x(), vcad_size_y(), 32, rmask, gmask, bmask, amask);
	if (ECAD_Surface != NULL) {
		glClearColor(0.0, 0.0, 0.0, 1.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		vcad_draw();
		gl_3d_export_cnc(ECAD_Surface, 10, 100);
		SDL_FreeSurface(ECAD_Surface);
	} else {
		fprintf(stderr, "Cant allocate Memory to draw 1:1 Image !!!\n");
		gui_percent = 0;
		sprintf(gui_info, "Cant allocate Memory to draw 1:1 Image !!!\n");
	}
	ECAD_Surface = Widget[WidgetID[EXPORT_IMAGE]].surface;
	if (review_raster == 1) {
		vcad_raster_view = 1;
	}
	vcad_select_delete();
	return 0;
}

SDL_Surface *hm_image = NULL;

int vcad_draw(void) {
	int vcad_id = 0;
	int n = 0;
	float vcad_raster2 = vcad_raster;
	boxRGBA(ECAD_Surface, 0, 0, ECAD_Surface->w - 1, ECAD_Surface->h - 1, 255, 255, 255, 255);
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
			vcad_drawit[ECAD[vcad_id].type](vcad_id);
		}
	}

// 	zoom_rotate(hm_image, ECAD_Surface, 1, 1, 0, 1.0);

	if (Widget[WidgetID[EXPORT_IMAGE]].view != 0) {
		// 2D-Raster
		if (vcad_zoom < 0.3) {
			vcad_raster2 = vcad_raster * 10.0;
		} else if (vcad_zoom < 0.7) {
			vcad_raster2 = vcad_raster * 4.0;
		} else if (vcad_zoom < 1.0) {
			vcad_raster2 = vcad_raster * 2.0;
		} else {
			vcad_raster2 = vcad_raster;
		}
		if (vcad_raster_view == 1) {
			for (n = 0; vcad_zoom_int((int)((float)n * vcad_raster2)) < ECAD_Surface->w; n++) {
				lineRGBA(ECAD_Surface, vcad_zoom_int((int)((float)n * vcad_raster2)), 0, vcad_zoom_int((int)((float)n * vcad_raster2)), ECAD_Surface->h, 40, 140, 40, 60);
			}
			for (n = 0; vcad_zoom_int((int)((float)n * vcad_raster2)) < ECAD_Surface->h; n++) {
				lineRGBA(ECAD_Surface, 0, vcad_zoom_int((int)((float)n * vcad_raster2)), ECAD_Surface->w, vcad_zoom_int((int)((float)n * vcad_raster2)), 40, 140, 40, 60);
			}
			for (n = 0; vcad_zoom_int((int)((float)n * (vcad_raster2 * 2))) < ECAD_Surface->w; n++) {
				lineRGBA(ECAD_Surface, vcad_zoom_int((int)((float)n * (vcad_raster2 * 2))), 0, vcad_zoom_int((int)((float)n * (vcad_raster2 * 2))), ECAD_Surface->h, 20, 120, 20, 80);
			}
			for (n = 0; vcad_zoom_int((int)((float)n * (vcad_raster2 * 2))) < ECAD_Surface->h; n++) {
				lineRGBA(ECAD_Surface, 0, vcad_zoom_int((int)((float)n * (vcad_raster2 * 2))), ECAD_Surface->w, vcad_zoom_int((int)((float)n * (vcad_raster2) * 2)), 20, 120, 20, 80);
			}
		}
		// 2D-Snap-Points
		for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
			if (ECAD[vcad_id].view != 0) {
				if (ECAD[vcad_id].selected == 0) {
					rectangleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1), vcad_zoom_x(ECAD[vcad_id].x2), vcad_zoom_y(ECAD[vcad_id].y2), 0, 0, 255, 60);
					circleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1), 3, 255, 0, 0, 60);
					circleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x2), vcad_zoom_y(ECAD[vcad_id].y2), 2, 255, 0, 0, 60);
				} else {
					rectangleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1), vcad_zoom_x(ECAD[vcad_id].x2), vcad_zoom_y(ECAD[vcad_id].y2), 0, 0, 255, 228);
					if (ECAD[vcad_id].selected == 1) {
						circleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1), 3, 255, 0, 0, 228);
						circleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x2), vcad_zoom_y(ECAD[vcad_id].y2), 2, 255, 0, 0, 128);
					} else {
						circleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1), 3, 255, 0, 0, 128);
						circleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x2), vcad_zoom_y(ECAD[vcad_id].y2), 2, 255, 0, 0, 228);
					}
				}
			}
		}
	} else {
		// Mouse-Cursor
		glBegin(GL_LINES);
		glColor4f(1.0, 0.0, 0.0, 1.0);
		glVertex3f(vcad_mouse_x1 - 20, vcad_mouse_y1 - 20, 257);
		glVertex3f(vcad_mouse_x1 + 20, vcad_mouse_y1 + 20, 257);
		glVertex3f(vcad_mouse_x1 + 20, vcad_mouse_y1 - 20, 257);
		glVertex3f(vcad_mouse_x1 - 20, vcad_mouse_y1 + 20, 257);
		glColor4f(1.0, 1.0, 0.0, 1.0);
		glVertex3f(vcad_mouse_x1 - 20, vcad_mouse_y1 - 20, 0);
		glVertex3f(vcad_mouse_x1 + 20, vcad_mouse_y1 + 20, 0);
		glVertex3f(vcad_mouse_x1 + 20, vcad_mouse_y1 - 20, 0);
		glVertex3f(vcad_mouse_x1 - 20, vcad_mouse_y1 + 20, 0);
		glColor4f(0.0, 1.0, 0.0, 1.0);
		glVertex3f(vcad_mouse_x1, vcad_mouse_y1, -100);
		glVertex3f(vcad_mouse_x1, vcad_mouse_y1, 257);
		glColor4f(1.0, 1.0, 0.0, 1.0);
		glVertex3f(vcad_mouse_x1, vcad_mouse_y1, 257);
		glVertex3f(vcad_mouse_x1, vcad_mouse_y1, 257 + 100);
		glEnd();

		// Null-Punkt
		glBegin(GL_LINES);
		glColor4f(1.0, 0.0, 0.0, 0.9);
		glVertex3f((float)vcad_offset_x - 100.0, (float)vcad_offset_y, 0.0);
		glVertex3f((float)vcad_offset_x + (float)ECAD_Surface->w + 100, (float)vcad_offset_y, 0.0);
		glColor4f(0.0, 1.0, 0.0, 0.9);
		glVertex3f((float)vcad_offset_x, (float)vcad_offset_y - 100.0, 0.0);
		glVertex3f((float)vcad_offset_x, (float)vcad_offset_y + (float)ECAD_Surface->h + 100, 0.0);
		glColor4f(0.0, 0.0, 1.0, 0.9);
		glVertex3f((float)vcad_offset_x, (float)vcad_offset_y, -100.0);
		glVertex3f((float)vcad_offset_x, (float)vcad_offset_y, 255.0);
		glEnd();
/*
		// Boden-Gitter
		glBegin(GL_LINES);
		glColor4f(1.0, 0.0, 0.0, 0.9);
		glVertex3f(-100.0, 0.0, 0.0);
		glVertex3f((float)ECAD_Surface->w + 100, 0.0, 0.0);
		glVertex3f(-100.0, (float)ECAD_Surface->h, 0.0);
		glVertex3f((float)ECAD_Surface->w + 100, (float)ECAD_Surface->h, 0.0);
		glColor4f(0.0, 1.0, 0.0, 0.9);
		glVertex3f(0.0, -100.0, 0.0);
		glVertex3f(0.0, (float)ECAD_Surface->h + 100, 0.0);
		glVertex3f((float)ECAD_Surface->w, -100.0, 0.0);
		glVertex3f((float)ECAD_Surface->w, (float)ECAD_Surface->h + 100, 0.0);
		glColor4f(0.0, 0.0, 1.0, 0.9);
		glVertex3f(0.0, 0.0, -100.0);
		glVertex3f(0.0, 0.0, 255.0);
		glVertex3f((float)ECAD_Surface->w, (float)ECAD_Surface->h, -100.0);
  		glVertex3f((float)ECAD_Surface->w, (float)ECAD_Surface->h, 255.0);
		glEnd();
		int ground_rsize = vcad_zoom_int(1000);
		glBegin(GL_LINES);
		for (n = 0; n < ECAD_Surface->w; n += ground_rsize) {
			glColor4f(0.0, 1.0, 0.0, 0.7);
			glVertex3f((float)n, 0.0, 0.0);
			glVertex3f((float)n, (float)ECAD_Surface->h, 0.0);
		}
		for (n = 0; n < ECAD_Surface->h; n += ground_rsize) {
			glColor4f(1.0, 1.0, 0.0, 0.7);
			glVertex3f(0.0, (float)n, 0.0);
			glVertex3f((float)ECAD_Surface->w, (float)n, 0.0);
		}*/
// 		glEnd();
// 		glBegin(GL_QUADS);
// 		glColor4f(0.5, 0.5, 0.5, 0.2);
// 		glVertex3f(0.0, 0.0, -1.0);
// 		glVertex3f((float)ECAD_Surface->w, 0.0, -1.0);
// 		glVertex3f((float)ECAD_Surface->w, (float)ECAD_Surface->h, -1.0);
// 		glVertex3f(0.0, (float)ECAD_Surface->h, -1.0);
// 		glEnd();

		// Object (HM->3D)
		if (vcad_raster_view == 1) {
			// Line-View
			glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
			gl_3d_export_quads(ECAD_Surface, 10);
		} else {
			// Fill-View
			gl_3d_export_quads(ECAD_Surface, 1);

			// Matterial-Kanten
/*			int material_rsize = vcad_zoom_int(1000);
			int mx = vcad_zoom_x(vcad_minsize_x()) - 1;
			int my = Widget[WidgetID[EXPORT_IMAGE]].h - vcad_zoom_y(vcad_minsize_y()) - 1;
			int sx = vcad_zoom_x(vcad_size_x()) + 1;
			int sy = Widget[WidgetID[EXPORT_IMAGE]].h - vcad_zoom_y(vcad_size_y()) + 1;
			glBegin(GL_LINES);
			glColor4f(0.0, 0.0, 1.0, 0.1);
			for (n = mx; n < sx; n += material_rsize) {
				glVertex3f((float)n, (float)my, 0.0);
				glVertex3f((float)n, (float)my, 200.0);
				glVertex3f((float)n, (float)my, 200.0);
				glVertex3f((float)n, (float)sy, 200.0);
				glVertex3f((float)n, (float)sy, 200.0);
				glVertex3f((float)n, (float)sy, 0.0);
			}
			for (n = my; n < sy; n += material_rsize) {
				glVertex3f((float)mx, (float)n, 0.0);
				glVertex3f((float)mx, (float)n, 200.0);
				glVertex3f((float)mx, (float)n, 200.0);
				glVertex3f((float)sx, (float)n, 200.0);
				glVertex3f((float)sx, (float)n, 200.0);
				glVertex3f((float)sx, (float)n, 0.0);
			}
			glEnd();*/
		}

	}
	return 0;
}

int vcad_image_raster_snap(void) {
	vcad_raster_snap = 1 - vcad_raster_snap;
	Widget[WidgetID[GRID_SNAP]].action = vcad_raster_snap + 1;
	return 0;
}

int vcad_image_raster_view(void) {
	vcad_raster_view = 1 - vcad_raster_view;
	Widget[WidgetID[GRID_VIEW]].action = vcad_raster_view + 1;
	return 0;
}

int vcad_add_snap_point(int x, int y) {
	y = Widget[WidgetID[EXPORT_IMAGE]].h - y;
	if (Widget[WidgetID[EXPORT_IMAGE]].view == 0) {
		glBegin(GL_LINES);
		glColor4f(255, 0, 0, 255);
		glVertex3f(x - 10, y - 10, 257);
		glVertex3f(x + 10, y + 10, 257);
		glColor4f(255, 0, 0, 255);
		glVertex3f(x + 10, y - 10, 257);
		glVertex3f(x - 10, y + 10, 257);
		glColor4f(255, 255, 155, 255);
		glVertex3f(x, y, -10);
		glVertex3f(x, y, 257);
		glColor4f(255, 155, 255, 255);
		glVertex3f(x, y, 257);
		glVertex3f(x, y, 257 + 50);
		glEnd();
	}
	return 0;
}

int vcad_move_group(int id, int diff_x1, int diff_y1) {
	int vcad_id;
	int group_id = ECAD[id].group;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].group == group_id) {
			ECAD[vcad_id].x1 -= diff_x1;
			ECAD[vcad_id].y1 -= diff_y1;
			ECAD[vcad_id].x2 -= diff_x1;
			ECAD[vcad_id].y2 -= diff_y1;
		}
	}
	return 0;
}

int vcad_move(void) {
	int vcad_id;
	int flag = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0 && ECAD[vcad_id].selected == 1) {
			if (ECAD[vcad_id].group == 0) {
				int diff_x = event.button.x - ECAD[vcad_id].x1;
				int diff_y = event.button.y - ECAD[vcad_id].y1;
				ECAD[vcad_id].x1 = event.button.x;
				ECAD[vcad_id].y1 = event.button.y;
				ECAD[vcad_id].x2 += diff_x;
				ECAD[vcad_id].y2 += diff_y;
			} else {
				vcad_move_group(vcad_id, ECAD[vcad_id].x1 - event.button.x, ECAD[vcad_id].y1 - event.button.y);
			}
			flag = 1;
		} else if (ECAD[vcad_id].view != 0 && ECAD[vcad_id].selected == 2) {
			if (ECAD[vcad_id].group == 0) {
				ECAD[vcad_id].x2 = event.button.x;
				ECAD[vcad_id].y2 = event.button.y;
			} else {
				vcad_move_group(vcad_id, ECAD[vcad_id].x2 - event.button.x, ECAD[vcad_id].y2 - event.button.y);
			}
			flag = 1;
		}
	}
	vcad_select_x1 = event.button.x;
	vcad_select_y1 = event.button.y;
	vcad_select_x2 = event.button.x;
	vcad_select_y2 = event.button.y;
	return 0;
}

int vcad_image_mover(void) {
	event.button.x = (int)((float)(event.button.x - Widget[WidgetID[EXPORT_IMAGE]].x) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.y = (int)((float)(event.button.y - Widget[WidgetID[EXPORT_IMAGE]].y) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	vcad_mouse_x1 = event.button.x;
	vcad_mouse_y1 = Widget[WidgetID[EXPORT_IMAGE]].h - event.button.y;
	event.button.x = vcad_unzoom_x(event.button.x);
	event.button.y = vcad_unzoom_y(event.button.y);
	if (vcad_raster_snap == 1) {
		event.button.x = ((int)((float)(event.button.x + (vcad_raster / 2)) / vcad_raster) * vcad_raster);
		event.button.y = ((int)((float)(event.button.y + (vcad_raster / 2)) / vcad_raster) * vcad_raster);
	}
	if (Widget[WidgetID[EXPORT_IMAGE]].view == 0) {
		SDL_ShowCursor(SDL_DISABLE);
	}
	if (vcad_mouse_mode == M_DRAW) {
		sprintf(gui_info, "Select: x=%0.2fmm, y=%0.2fmm", (float)event.button.x / 100.0, (float)event.button.y / 100.0);
		if (vcad_mover[vcad_mode] != NULL) {
			vcad_mover[vcad_mode]();
		}
	} else if (vcad_mouse_mode == M_SELECT) {
		if (event.button.button == 1) {
			vcad_move();
		} else if (event.button.button == 2) {
			int vcad_id;
			for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
				if (ECAD[vcad_id].view != 0) {
					if (ECAD[vcad_id].x1 == vcad_select_x1 && ECAD[vcad_id].y1 == vcad_select_y1) {
						ECAD[vcad_id].x1 = event.button.x;
						ECAD[vcad_id].y1 = event.button.y;
						break;
					} else if (ECAD[vcad_id].x2 == vcad_select_x1 && ECAD[vcad_id].y2 == vcad_select_y1) {
						ECAD[vcad_id].x2 = event.button.x;
						ECAD[vcad_id].y2 = event.button.y;
						break;
					}
				}
			}
			vcad_select_x1 = event.button.x;
			vcad_select_y1 = event.button.y;
			vcad_select_x2 = event.button.x;
			vcad_select_y2 = event.button.y;
		} else {
			int vcad_id = 0;
			sprintf(gui_info, "Koordinaten: x=%0.2fmm, y=%0.2fmm (%0.3fcm,%0.3fcm)", (float)event.button.x / 100.0, (float)event.button.y / 100.0, (float)event.button.x / 1000.0, (float)event.button.y / 1000.0);
/*			vcad_select_num = -1;
			for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
				if (ECAD[vcad_id].view != 0 && ECAD[vcad_id].selected == 1) {
					if (ECAD[vcad_id].x1 == event.button.x && ECAD[vcad_id].y1 == event.button.y) {
						sprintf(gui_info, "Object: %s (%i)", ECAD[vcad_id].info, vcad_id);
						vcad_select_num = vcad_id;
						vcad_movemode = 0;
						vcad_select_x1 = event.button.x;
						vcad_select_y1 = event.button.y;
						vcad_select_x2 = event.button.x;
						vcad_select_y2 = event.button.y;
						return 0;
					} else if (ECAD[vcad_id].x2 == event.button.x && ECAD[vcad_id].y2 == event.button.y) {
						sprintf(gui_info, "Object: %s (%i)", ECAD[vcad_id].info, vcad_id);
						vcad_select_num = vcad_id;
						vcad_movemode = 1;
						vcad_select_x1 = event.button.x;
						vcad_select_y1 = event.button.y;
						vcad_select_x2 = event.button.x;
						vcad_select_y2 = event.button.y;
						return 0;
					}
				}
			}*/
		}
	} else {
		sprintf(gui_info, "Koordinaten: x=%0.2fmm, y=%0.2fmm", (float)event.button.x / 100.0, (float)event.button.y / 100.0);
	}
	return 0;
}

int vcad_image_mdown(void) {
	event.button.x = (int)((float)(event.button.x - Widget[WidgetID[EXPORT_IMAGE]].x) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.y = (int)((float)(event.button.y - Widget[WidgetID[EXPORT_IMAGE]].y) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	if (vcad_mouse_mode == M_SELECT) {
		if (event.button.button == 3) {
			vcad_offset_x = event.button.x;
			vcad_offset_y = event.button.y;
			return 0;
		}
	}
	event.button.x = vcad_unzoom_x(event.button.x);
	event.button.y = vcad_unzoom_y(event.button.y);
	if (vcad_raster_snap == 1) {
		event.button.x = ((int)((float)(event.button.x + (vcad_raster / 2)) / vcad_raster) * vcad_raster);
		event.button.y = ((int)((float)(event.button.y + (vcad_raster / 2)) / vcad_raster) * vcad_raster);
	}
	if (vcad_mouse_mode == M_DRAW) {
		if (vcad_mdown[vcad_mode] != NULL) {
			vcad_mdown[vcad_mode]();
		}
	} else if (vcad_mouse_mode == M_SELECT) {
		if (event.button.button == 1) {
			vcad_select_x1 = event.button.x;
			vcad_select_y1 = event.button.y;
			vcad_select_x2 = vcad_select_x1;
			vcad_select_y2 = vcad_select_y1;
			sprintf(gui_info, "Move-Selection x=%i, y=%i", vcad_select_x2, vcad_select_y2);
			int vcad_id = 0;
			for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
				if (ECAD[vcad_id].view != 0) {
					if (ECAD[vcad_id].x1 > vcad_select_x1 - vcad_unzoom_int(10) && ECAD[vcad_id].x1 < vcad_select_x1 + vcad_unzoom_int(10) && ECAD[vcad_id].y1 > vcad_select_y1 - vcad_unzoom_int(10) && ECAD[vcad_id].y1 < vcad_select_y1 + vcad_unzoom_int(10)) {
						sprintf(gui_info, "Select %s: x=%i, y=%i (%i)", ECAD[vcad_id].info, vcad_select_x1, vcad_select_y1, vcad_id);
						ECAD[vcad_id].selected = 1;
						vcad_active_id = vcad_id;
					} else if (ECAD[vcad_id].x2 > vcad_select_x1 - vcad_unzoom_int(10) && ECAD[vcad_id].x2 < vcad_select_x1 + vcad_unzoom_int(10) && ECAD[vcad_id].y2 > vcad_select_y1 - vcad_unzoom_int(10) && ECAD[vcad_id].y2 < vcad_select_y1 + vcad_unzoom_int(10)) {
						sprintf(gui_info, "Select %s: x=%i, y=%i (%i)", ECAD[vcad_id].info, vcad_select_x1, vcad_select_y1, vcad_id);
						ECAD[vcad_id].selected = 2;
						vcad_active_id = vcad_id;
					} else {
						ECAD[vcad_id].selected = 0;
					}
				} else {
					ECAD[vcad_id].selected = 0;
				}
			}
		} else if (event.button.button == 4) {
			if (vcad_zoom > vcad_zoom_diff * 2) {
				vcad_zoom -= vcad_zoom_diff;
			}
			sprintf(gui_info, "Zoom Out: %0.2f fach", vcad_zoom);
		} else if (event.button.button == 5) {
			vcad_zoom += vcad_zoom_diff;
			sprintf(gui_info, "Zoom In: %0.2f fach", vcad_zoom);
		}
	}
	return 0;
}

int vcad_image_mup(void) {
	event.button.x = (int)((float)(event.button.x - Widget[WidgetID[EXPORT_IMAGE]].x) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.y = (int)((float)(event.button.y - Widget[WidgetID[EXPORT_IMAGE]].y) / Widget[WidgetID[EXPORT_IMAGE]].zoom);
	event.button.x = vcad_unzoom_x(event.button.x);
	event.button.y = vcad_unzoom_y(event.button.y);
	if (vcad_raster_snap == 1) {
		event.button.x = ((int)((float)(event.button.x + (vcad_raster / 2)) / vcad_raster) * vcad_raster);
		event.button.y = ((int)((float)(event.button.y + (vcad_raster / 2)) / vcad_raster) * vcad_raster);
	}
	if (event.button.button == 1) {
		if (vcad_mouse_mode == M_DRAW) {
			if (vcad_mup[vcad_mode] != NULL) {
				vcad_mup[vcad_mode]();
			}
		} else if (vcad_mouse_mode == M_SELECT) {
			vcad_active_id = vcad_get_free_id();
		}
/*	} else if (event.button.button == 3) {
		if (vcad_mouse_mode == M_SELECT) {
			vcad_select_x2 = event.button.x;
			vcad_select_y2 = event.button.y;
			sprintf(gui_info, "End-Selection x=%i, y=%i", vcad_select_x2, vcad_select_y2);
			int vcad_id = 0;
			for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
				if (ECAD[vcad_id].view != 0) {
					if (ECAD[vcad_id].y1 >= vcad_select_y1 && ECAD[vcad_id].y1 <= vcad_select_y2) {
						if (ECAD[vcad_id].x1 >= vcad_select_x1 && ECAD[vcad_id].x1 <= vcad_select_x2) {
							sprintf(gui_info, "Entferne %s (%i)", ECAD[vcad_id].info, vcad_id);
							vcad_active_id = vcad_id;
							vcad_clean_select();
							if (vcad_select_x1 == vcad_select_x2 && vcad_select_y1 == vcad_select_y2) {
								vcad_select_x1 = 0;
								vcad_select_y1 = 0;
								vcad_select_x2 = 0;
								vcad_select_y2 = 0;
								return 0;
							}
						}
					}
				}
			}
			vcad_select_x1 = 0;
			vcad_select_y1 = 0;
			vcad_select_x2 = 0;
			vcad_select_y2 = 0;
		}*/
	}
	return 0;
}

int vcad_view_3d(void) {
	Widget[WidgetID[EXPORT_IMAGE]].type = 4;
	Widget[WidgetID[EXPORT_IMAGE]].view = 1 - Widget[WidgetID[EXPORT_IMAGE]].view;
	return 0;
}

int vcad_image_input(char *txt_str) {
	if (vcad_mouse_mode == M_DRAW) {
		if (vcad_input[vcad_mode] != NULL) {
			return (*vcad_input[vcad_mode])(txt_str);
		}
	}
	if (strcmp(txt_str, "[-]") == 0) {
		if (vcad_zoom > vcad_zoom_diff * 2) {
			vcad_zoom -= vcad_zoom_diff;
		}
		sprintf(gui_info, "Zoom Out: %0.2f fach", vcad_zoom);
	} else if (strcmp(txt_str, "[+]") == 0) {
		vcad_zoom += vcad_zoom_diff;
		sprintf(gui_info, "Zoom In: %0.2f fach", vcad_zoom);
	} else if (strcmp(txt_str, "[4]") == 0) {
		vcad_offset_x -= 10;
	} else if (strcmp(txt_str, "[6]") == 0) {
		vcad_offset_x += 10;
	} else if (strcmp(txt_str, "[8]") == 0) {
		vcad_offset_y += 10;
	} else if (strcmp(txt_str, "[2]") == 0) {
		vcad_offset_y -= 10;
	} else if (Widget[WidgetID[EXPORT_IMAGE]].view == 1) {
		if (strcmp(txt_str, "left") == 0) {
			vcad_offset_x -= 10;
		} else if (strcmp(txt_str, "right") == 0) {
			vcad_offset_x += 10;
		} else if (strcmp(txt_str, "up") == 0) {
			vcad_offset_y += 10;
		} else if (strcmp(txt_str, "down") == 0) {
			vcad_offset_y -= 10;
		} else if (strcmp(txt_str, "page up") == 0) {
			if (vcad_zoom > vcad_zoom_diff * 2) {
				vcad_zoom -= vcad_zoom_diff;
			}
			sprintf(gui_info, "Zoom Out: %0.2f fach", vcad_zoom);
		} else if (strcmp(txt_str, "page down") == 0) {
			vcad_zoom += vcad_zoom_diff;
			sprintf(gui_info, "Zoom In: %0.2f fach", vcad_zoom);
		}
	} else {
		static float winkel = 9.0;
		glTranslatef(Widget[WidgetID[EXPORT_IMAGE]].w / 2, Widget[WidgetID[EXPORT_IMAGE]].h / 2, 128);
		if (strcmp(txt_str, "f9") == 0) {
			winkel /= 2;
			sprintf(gui_info, "Dreh-Winkel: %0.1f", winkel);
		} else if (strcmp(txt_str, "f10") == 0) {
			winkel *= 2;
			sprintf(gui_info, "Dreh-Winkel: %0.1f", winkel);
		} else if (strcmp(txt_str, "left") == 0) {
			glRotatef(-winkel, 0.0, 1.0, 0.0);
		} else if (strcmp(txt_str, "right") == 0) {
			glRotatef(winkel, 0.0, 1.0, 0.0);
		} else if (strcmp(txt_str, "up") == 0) {
			glRotatef(-winkel, 1.0, 0.0, 0.0);
		} else if (strcmp(txt_str, "down") == 0) {
			glRotatef(winkel, 1.0, 0.0, 0.0);
		} else if (strcmp(txt_str, "page up") == 0) {
			glRotatef(winkel, 0.0, 0.0, 1.0);
		} else if (strcmp(txt_str, "page down") == 0) {
			glRotatef(-winkel, 0.0, 0.0, 1.0);
		}
		glTranslatef(-Widget[WidgetID[EXPORT_IMAGE]].w / 2, -Widget[WidgetID[EXPORT_IMAGE]].h / 2, -128);
	}
	return -1;
}

int vcad_select_delete(void) {
	vcad_mouse_mode = M_SELECT;
	gui_select_icon(WidgetID[DRAW_SELECT]);
	vcad_clean_select();
	return 0;
}

int vcad_select_move(void) {
	vcad_mouse_mode = M_SELECT;
	vcad_clean_select();
	gui_select_icon(WidgetID[DRAW_MOVE]);
	return 0;
}

int vcad_init(void) {
	int vcad_id = 0;
	ECAD_Surface = Widget[WidgetID[EXPORT_IMAGE]].surface;
	hm_image = IMG_Load("/tmp/face.bmp");
	vcad_mode = 0;
	vcad_mode = 0;
	vcad_select = 0;
	vcad_active_id = 0;
	vcad_export = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		ECAD[vcad_id].type = 0;
		ECAD[vcad_id].x1 = 0;
		ECAD[vcad_id].y1 = 0;
		ECAD[vcad_id].x2 = 0;
		ECAD[vcad_id].y2 = 0;
		ECAD[vcad_id].rotate = 0;
		ECAD[vcad_id].size = 0;
		ECAD[vcad_id].dtype = 0;
		ECAD[vcad_id].mode = 0;
		ECAD[vcad_id].view = 0;
		ECAD[vcad_id].layer = 0;
		ECAD[vcad_id].group = 0;
		ECAD[vcad_id].selected = 0;
		ECAD[vcad_id].text[0] = 0;
		ECAD[vcad_id].info[0] = 0;
	}
	vcad_select_delete();
	vcad_clean_select();

	strcpy(vcad_filename, "Unnamed.vcad");
	return 0;
}


