
#define M_NONE        0
#define M_SELECT      1
#define M_DRAW        2

#define SELECT_XY1    0
#define SELECT_XY2    1
#define SELECT_Z12    2
#define SELECT_Z1     3
#define SELECT_Z2     3
#define SELECT_SIZE   5
#define SELECT_ROTATE 6
#define SELECT_TEXT   7

#define ECAD_MAX      10000

typedef struct {
	int x1;
	int y1;
	int z1;
	int x2;
	int y2;
	int z2;
	int xoff;
	int yoff;
	int rotate;
	unsigned int size;
	unsigned int group;
	unsigned int type;
	unsigned char zflipx;
	unsigned char zflipy;
	unsigned char dtype;
	unsigned char mode;
	unsigned char view;
	unsigned char layer;
	unsigned char selected;
	char text[512];
	char info[64];
} Ecad_Element;
Ecad_Element ECAD[ECAD_MAX];

SDL_Surface *ECAD_Surface;

int (*vcad_drawit[ECAD_MAX]) (int vcad_id);
int (*vcad_mover[ECAD_MAX]) (void);
int (*vcad_mdown[ECAD_MAX]) (void);
int (*vcad_mup[ECAD_MAX]) (void);
int (*vcad_input[ECAD_MAX]) (char *txt_str);
char vcad_filename[512];
int vcad_active_id = 0;
int vcad_active_layer = 0;
int vcad_mouse_mode = 0;
int vcad_mode = 0;
int vcad_select = 0;
int vcad_x1 = 0;
int vcad_y1 = 0;
int vcad_z1 = 0;
int vcad_x2 = 0;
int vcad_y2 = 0;
int vcad_z2 = 0;
int vcad_rotate = 0;
int vcad_padtype = 0;
int vcad_mounttype = 0;
int vcad_resistortype = 0;
float vcad_raster_snap = 1;
float vcad_raster_view = 1;
int vcad_select_x1 = 0;
int vcad_select_y1 = 0;
int vcad_select_x2 = 0;
int vcad_select_y2 = 0;
int vcad_select_num = 0;
int vcad_export = 0;
int vcad_movemode = 0;
int vcad_group_id = 1;
float vcad_zoom_diff = 0.02;

float vcad_zoom = 0.1;
float vcad_raster = 10;
int vcad_linesize = 50;
int vcad_textsize = 110;
int vcad_padsize = 180;
int vcad_mountsize = 200;
int vcad_offset_x = 0;
int vcad_offset_y = 0;
int vcad_mouse_x1 = 0;
int vcad_mouse_y1 = 0;

int vcad_show_top_label = 1;
int vcad_show_bottom_cu = 1;
int vcad_show_drill = 1;

int bc_r = 0;
int bc_g = 0;
int bc_b = 0;
int bc_a = 0;
int tl_r = 0;
int tl_g = 0;
int tl_b = 0;
int tl_a = 0;
int d_r = 0;
int d_g = 0;
int d_b = 0;
int d_a = 0;


int vcad_add_pad(int x1, int y1, int size, int dtype);
int vcad_zoom_int(int value);
int vcad_unzoom_int(int value);
int vcad_clean_select(void);
int vcad_file_load(char *filename);
int vcad_file_save(char *filename);
int vcad_get_free_id(void);
int vcad_toggle_show_top_label(void);
int vcad_toggle_show_bottom_cu(void);
int vcad_toggle_show_drill(void);
int vcad_set_color(int vcad_id);
int vcad_draw(void);
int vcad_image_raster_snap(void);
int vcad_image_raster_view(void);
int vcad_image_mover(void);
int vcad_image_mdown(void);
int vcad_image_mup(void);
int vcad_image_input(char *txt_str);
int vcad_select_delete(void);
int vcad_init(void);
