
int vcad_select_circle(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "Bohrung selected");
		vcad_select = SELECT_XY1;
		vcad_mouse_mode = M_DRAW;
		vcad_mode = DRAW_CIRCLE;
		vcad_clean_select();
		gui_select_icon(WidgetID[DRAW_CIRCLE]);
	}
	return 0;
}

int vcad_set_circle(int mode, int layer, int x1, int y1, int z1, int x2, int y2, int z2, int line_size) {
	ECAD[vcad_active_id].type = DRAW_CIRCLE;
	ECAD[vcad_active_id].x1 = x1;
	ECAD[vcad_active_id].y1 = y1;
	ECAD[vcad_active_id].z1 = z1;
	ECAD[vcad_active_id].x2 = x2;
	ECAD[vcad_active_id].y2 = y2;
	ECAD[vcad_active_id].z2 = z2;
	ECAD[vcad_active_id].xoff = 0;
	ECAD[vcad_active_id].yoff = 0;
	ECAD[vcad_active_id].size = line_size;
	ECAD[vcad_active_id].dtype = vcad_padtype;
	ECAD[vcad_active_id].rotate = 0;
	ECAD[vcad_active_id].mode = mode;
	ECAD[vcad_active_id].view = 1;
	ECAD[vcad_active_id].layer = vcad_active_layer;
	ECAD[vcad_active_id].text[0] = 0;
	strcpy(ECAD[vcad_active_id].info, "Bohrung");
	return 0;
}

int vcad_draw_circle(int vcad_id) {
	int size_n = 0;
	int r = 0;
	int g = 0;
	int b = 0;
	int a = 255;
	filledCircleRGBA(ECAD_Surface, vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1), vcad_zoom_int(ECAD[vcad_id].x2) - vcad_zoom_int(ECAD[vcad_id].x1), ECAD[vcad_id].z1, ECAD[vcad_id].z1, ECAD[vcad_id].z1, 255);
	vcad_add_snap_point(vcad_zoom_x(ECAD[vcad_id].x1), vcad_zoom_y(ECAD[vcad_id].y1));
	vcad_add_snap_point(vcad_zoom_x(ECAD[vcad_id].x2), vcad_zoom_y(ECAD[vcad_id].y2));
	return 0;
}

int vcad_mdown_circle(void) {
	if (event.button.button == 1) {
		if (vcad_select == SELECT_XY1) {
			vcad_x1 = event.button.x;
			vcad_y1 = event.button.y;
			vcad_x2 = vcad_x1 + 50;
			vcad_y2 = vcad_y1 + 50;
			vcad_z1 = 128;
			vcad_z2 = 128;
			vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
		}
	} else if (event.button.button == 3) {
		vcad_clean_select();
	} else if (event.button.button == 4) {
		if (vcad_select == SELECT_XY2) {
			vcad_z1++;
			vcad_z2++;
		}
	} else if (event.button.button == 5) {
		if (vcad_select == SELECT_XY2) {
			vcad_z1--;
			vcad_z2--;
		}
	}
	return 0;
}

int vcad_mup_circle(void) {
	if (event.button.button == 1) {
		if (vcad_select == SELECT_XY1) {
			vcad_x1 = event.button.x;
			vcad_y1 = event.button.y;
			vcad_x2 = vcad_x1 + 50;
			vcad_y2 = vcad_y1 + 50;
			vcad_select = SELECT_XY2;
			vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
		} else if (vcad_select == SELECT_XY2) {
			vcad_x2 = event.button.x;
			vcad_y2 = vcad_y1 + (vcad_x1 - vcad_x2);
			vcad_select = SELECT_Z12;
			vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
		} else if (vcad_select == SELECT_Z12) {
			vcad_z1 = (event.button.x - vcad_x1) / 3;
			vcad_z2 = (event.button.y - vcad_y1) / 3;
			if (vcad_z1 > 255) {vcad_z1 = 255;} else if (vcad_z1 < 0) {vcad_z1 = 0;}
			if (vcad_z2 > 255) {vcad_z2 = 255;} else if (vcad_z2 < 0) {vcad_z2 = 0;}
			vcad_select = SELECT_XY1;
			vcad_set_circle(1, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
			vcad_active_id = vcad_get_free_id();
		}
	}
	return 0;
}

int vcad_mover_circle(void) {
	if (vcad_select == SELECT_XY1) {
		vcad_x1 = event.button.x;
		vcad_y1 = event.button.y;
		vcad_x2 = vcad_x1 + 50;
		vcad_y2 = vcad_y1 + 50;
		sprintf(gui_info, "Bohrung: Possition: x=%0.2fmm, y=%0.2fmm", (float)vcad_x1 / 100.0, (float)vcad_y1 / 100.0);
		vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
	} else if (vcad_select == SELECT_XY2) {
		vcad_x2 = event.button.x;
		vcad_y2 = vcad_y1 + (vcad_x1 - vcad_x2);
		sprintf(gui_info, "Bohrung: Radius: x=%0.2fmm, y=%0.2fmm --> x=%0.2fmm, y=%0.2fmm (w=%0.2fmm, h=%0.2fmm d=%0.2fmm)", (float)(vcad_x1) / 100.0, (float)(vcad_y1) / 100.0, (float)(vcad_x2) / 100.0, (float)(vcad_y2) / 100.0, (float)(vcad_x2 - vcad_x1) / 100.0, (float)(vcad_y2 - vcad_y1) / 100.0, (float)(255 - vcad_z1) / 100.0);
		vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
	} else if (vcad_select == SELECT_Z12) {
		vcad_z1 = (event.button.x - vcad_x1) / 3;
		vcad_z2 = (event.button.y - vcad_y1) / 3;
		if (vcad_z1 > 255) {vcad_z1 = 255;} else if (vcad_z1 < 0) {vcad_z1 = 0;}
		if (vcad_z2 > 255) {vcad_z2 = 255;} else if (vcad_z2 < 0) {vcad_z2 = 0;}
		sprintf(gui_info, "Bohrung: Tiefe: x=%0.2fmm, y=%0.2fmm --> x=%0.2fmm, y=%0.2fmm (w=%0.2fmm, h=%0.2fmm d=%0.2fmm)", (float)(vcad_x1) / 100.0, (float)(vcad_y1) / 100.0, (float)(vcad_x2) / 100.0, (float)(vcad_y2) / 100.0, (float)(vcad_x2 - vcad_x1) / 100.0, (float)(vcad_y2 - vcad_y1) / 100.0, (float)(255 - vcad_z1) / 100.0);
		vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
	}
	return 0;
}

int vcad_input_circle(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (vcad_select == SELECT_XY1 && (strstr(tmp_str, ",") == 0 && (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0))) {
		tmp_str[str_ptr++] = ',';
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if (vcad_select != SELECT_XY1 || (loc = strstr(tmp_str, ",")) != 0) {
			if (vcad_select == SELECT_XY1) {
				vcad_x1 = atoi(tmp_str);
				vcad_y1 = atoi(loc + 1);
				vcad_x2 = vcad_x1 + 50;
				vcad_y2 = vcad_y1 + 50;
				vcad_select = SELECT_XY2;
				vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
			} else if (vcad_select == SELECT_XY2) {
				vcad_x2 = vcad_x1 + atoi(tmp_str);
				vcad_y2 = vcad_y1 + atoi(tmp_str);
				vcad_select = SELECT_Z12;
				vcad_set_circle(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
			} else if (vcad_select == SELECT_Z12) {
				vcad_z1 = atoi(tmp_str);
				vcad_z2 = vcad_z1;
				if (vcad_z1 > 255) {vcad_z1 = 255;} else if (vcad_z1 < 0) {vcad_z1 = 0;}
				if (vcad_z2 > 255) {vcad_z2 = 255;} else if (vcad_z2 < 0) {vcad_z2 = 0;}
				vcad_select = SELECT_XY1;
				vcad_set_circle(1, vcad_active_layer, vcad_x1, vcad_y1, vcad_z1, vcad_x2, vcad_y2, vcad_z2, vcad_linesize);
				vcad_active_id = vcad_get_free_id();
			}
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	if (vcad_select == SELECT_XY1) {
		sprintf(gui_info, "Bohrung: Possition: x=?, y=? (%s)", tmp_str);
	} else if (vcad_select == SELECT_XY2) {
		sprintf(gui_info, "Bohrung: Radius: x=%i, y=%i --> x=?, y=? (%s)", vcad_x1, vcad_y1, tmp_str);
	} else if (vcad_select == SELECT_Z12) {
		sprintf(gui_info, "Bohrung: Tiefe: x=%i, y=%i --> x=?, y=? (%s)", vcad_x1, vcad_y1, tmp_str);
	}
	return 0;
}


