
int vcad_select_line(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "Line selected");
		vcad_select = SELECT_XY1;
		vcad_mouse_mode = M_DRAW;
		vcad_mode = DRAW_LINE;
		vcad_clean_select();
		gui_select_icon(WidgetID[DRAW_LINE]);
	} else if (event.button.button == 4) {
		vcad_linesize++;
		sprintf(gui_info, "Line-Size: %i", vcad_linesize);
	} else if (event.button.button == 5) {
		if (vcad_linesize > 1) {
			vcad_linesize--;
		}
		sprintf(gui_info, "Line-Size: %i", vcad_linesize);
	}
	return 0;
}

int vcad_set_line(int mode, int layer, int x1, int y1, int x2, int y2, int line_size) {
	ECAD[vcad_active_id].type = DRAW_LINE;
	ECAD[vcad_active_id].x1 = x1;
	ECAD[vcad_active_id].y1 = y1;
	ECAD[vcad_active_id].x2 = x2;
	ECAD[vcad_active_id].y2 = y2;
	ECAD[vcad_active_id].size = line_size;
	ECAD[vcad_active_id].dtype = vcad_padtype;
	ECAD[vcad_active_id].rotate = 0;
	ECAD[vcad_active_id].mode = mode;
	ECAD[vcad_active_id].view = 1;
	ECAD[vcad_active_id].layer = vcad_active_layer;
	ECAD[vcad_active_id].group = 0;
	ECAD[vcad_active_id].text[0] = 0;
	strcpy(ECAD[vcad_active_id].info, "Leiterbahn");
	return 0;
}

int vcad_draw_line(int vcad_id) {
	int size_n = 0;
	if (vcad_show_bottom_cu == 1) {
		for (size_n = 0; size_n < vcad_zoom_int(ECAD[vcad_id].size / 2); size_n++) {
			lineRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x1) + size_n, vcad_zoom_int(ECAD[vcad_id].y1), vcad_zoom_int(ECAD[vcad_id].x2) + size_n, vcad_zoom_int(ECAD[vcad_id].y2), bc_r, bc_g, bc_b, bc_a);
			lineRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x1), vcad_zoom_int(ECAD[vcad_id].y1) + size_n, vcad_zoom_int(ECAD[vcad_id].x2), vcad_zoom_int(ECAD[vcad_id].y2) + size_n, bc_r, bc_g, bc_b, bc_a);
		}
		for (size_n = 0; size_n < vcad_zoom_int(ECAD[vcad_id].size / 2); size_n++) {
			lineRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x1) - size_n, vcad_zoom_int(ECAD[vcad_id].y1), vcad_zoom_int(ECAD[vcad_id].x2) - size_n, vcad_zoom_int(ECAD[vcad_id].y2), bc_r, bc_g, bc_b, bc_a);
			lineRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x1), vcad_zoom_int(ECAD[vcad_id].y1) - size_n, vcad_zoom_int(ECAD[vcad_id].x2), vcad_zoom_int(ECAD[vcad_id].y2) - size_n, bc_r, bc_g, bc_b, bc_a);
		}
// 		filledCircleRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x1), vcad_zoom_int(ECAD[vcad_id].y1), vcad_zoom_int(((ECAD[vcad_id].size - 2) / 2)), bc_r, bc_g, bc_b, bc_a);
// 		filledCircleRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x2), vcad_zoom_int(ECAD[vcad_id].y2), vcad_zoom_int(((ECAD[vcad_id].size - 2) / 2)), bc_r, bc_g, bc_b, bc_a);
		int x1 = vcad_zoom_int(ECAD[vcad_id].x1);
		int y1 = vcad_zoom_int(ECAD[vcad_id].y1);
		int x2 = vcad_zoom_int(ECAD[vcad_id].x2);
		int y2 = vcad_zoom_int(ECAD[vcad_id].y2);
		glBegin(GL_LINES);
		glColor3f(0.5, 0.5, 0.5);
		glVertex3f(x1, y1, 0.2);
		glVertex3f(x2, y2, 0.2);
		glColor3f(0.3, 0.3, 0.2);
		glVertex3f(x1, y1, -200.0 * vcad_zoom - 0.2);
		glVertex3f(x2, y2, -200.0 * vcad_zoom - 0.2);
		glEnd();
	}
	return 0;
}

int vcad_mdown_line(void) {
	if (event.button.button == 1) {
		if (vcad_select == SELECT_XY1) {
			vcad_x1 = event.button.x;
			vcad_y1 = event.button.y;
			vcad_x2 = vcad_x1;
			vcad_y2 = vcad_y1;
			vcad_set_line(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
		}
	}
	return 0;
}

int vcad_mup_line(void) {
	if (event.button.button == 1) {
		if (vcad_select == SELECT_XY1) {
			vcad_x1 = event.button.x;
			vcad_y1 = event.button.y;
			vcad_x2 = vcad_x1;
			vcad_y2 = vcad_y1;
			vcad_select = SELECT_XY2;
			vcad_set_line(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
		} else if (vcad_select == SELECT_XY2) {
			vcad_x2 = event.button.x;
			vcad_y2 = event.button.y;
			vcad_select = SELECT_XY1;
			vcad_set_line(1, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
			vcad_active_id = vcad_get_free_id();
		}
	}
	return 0;
}

int vcad_mover_line(void) {
	if (vcad_select == SELECT_XY1) {
		vcad_x1 = event.button.x;
		vcad_y1 = event.button.y;
		vcad_x2 = vcad_x1;
		vcad_y2 = vcad_y1;
		sprintf(gui_info, "Line-Start-Possition: x=%0.1fmm, y=%0.1fmm", (float)vcad_x1 / 10.0, (float)vcad_y1 / 10.0);
		vcad_set_line(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
	} else if (vcad_select == SELECT_XY2) {
		vcad_x2 = event.button.x;
		vcad_y2 = event.button.y;
		sprintf(gui_info, "Line-End-Possition: x=%i, y=%i --> x=%i, y=%i (w=%i, h=%i)", vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_x2 - vcad_x1, vcad_y2 - vcad_y1);
		vcad_set_line(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
	}
	return 0;
}

int vcad_input_line(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strstr(tmp_str, ",") == 0 && (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0)) {
		tmp_str[str_ptr++] = ',';
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			if (vcad_select == SELECT_XY1) {
				vcad_x1 = atoi(tmp_str);
				vcad_y1 = atoi(loc + 1);
				vcad_x2 = vcad_x1;
				vcad_y2 = vcad_y1;
				vcad_select = SELECT_XY2;
				vcad_set_line(0, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
			} else if (vcad_select == SELECT_XY2) {
				vcad_x2 = atoi(tmp_str);
				vcad_y2 = atoi(loc + 1);
				vcad_select = SELECT_XY1;
				vcad_set_line(1, vcad_active_layer, vcad_x1, vcad_y1, vcad_x2, vcad_y2, vcad_linesize);
				vcad_active_id = vcad_get_free_id();
			}
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	if (vcad_select == SELECT_XY1) {
		sprintf(gui_info, "Line-Start-Possition: x=?, y=? (%s)", tmp_str);
	} else if (vcad_select == SELECT_XY2) {
		sprintf(gui_info, "Line-End-Possition: x=%i, y=%i --> x=?, y=? (%s)", vcad_x1, vcad_y1, tmp_str);
	}
	return 0;
}


