
#define GROUP_MAIN			0
#define GROUP_TOOLBAR			1
#define GROUP_GRID			2
#define GROUP_DIRLIST			3

#define ICON_NEW			11
#define ICON_LOAD			12
#define ICON_SAVE			13
#define ICON_SAVE_IMG			14
#define ICON_SAVE_HM			15
#define ICON_UNDO			16
#define ICON_EXIT			17
#define ICON_SAVE_IMAGE			18
#define ICON_EXPORT_PDF			19
#define ICON_PRINT_IMAGE		20
#define OBJECT_LIST			21
#define EXPORT_IMAGE			22
#define ICON_SAVE_HM1			23
#define ICON_SAVE_HM2			24

SDL_Surface *tmp_image = NULL;
char directory_path[512];
char dirlist_str[4096];

#define DRAW_SELECT           30
#define DRAW_MOVE             31
#define DRAW_LINE             32
#define DRAW_TEXT             33
#define DRAW_BOX              34
#define DRAW_CIRCLE           35
#define DRAW_RECTANGLE        36
#define DRAW_RECGARD          37
#define DRAW_CIRCGARD         38
#define DRAW_RECCIRC          39

#define GRID_SNAP             50
#define GRID_VIEW             51
#define TOGGLE_SHOW_TOP_LABEL 53
#define TOGGLE_SHOW_BOTTOM_CU 54
#define TOGGLE_SHOW_DRILL     55
#define TOGGLE_SHOW_3D        56

#include "cnc-struct.c"
#include "cnc.c"
#include "cnc-interface.h"
#include "cnc-interface.c"
#include "cnc_2d_liner.c"
#include "cnc_2d_outliner.c"
#include "cnc_2d_fill.c"
#include "cnc_2d_fill_objects.c"
#include "vcad.c"

int frontend_mdown_object_list(void) {
	static int mode = 0;
	int selected = (event.button.y - Widget[WidgetID[100]].y) / 20;
	char tmp_str[4096];
	char tmp2_str[4096];
	char *loc1;
	char *loc2;
	int n = 0;
	loc2 = dirlist_str;
	while ((loc1 = strstr(loc2, ";")) != 0) {
		strcpy(tmp_str, loc2);
		tmp_str[strstr(tmp_str, ";") - tmp_str] = 0;
		loc2 = loc1 + 1;
		if (n++ == selected) {
			if (strcmp(tmp2_str, "..") == 0) {
				dirname(directory_path);
				frontend_mdown_load();
			} else {
				sprintf(tmp2_str, "%s/%s", directory_path, tmp_str);
				if (frontend_is_directory(tmp2_str) == 1) {
					strcpy(directory_path, tmp2_str);
					frontend_mdown_load();
				} else {
					sprintf(tmp_str, "Volume-CAD (%s)", tmp2_str);
					SDL_WM_SetCaption(tmp_str, tmp_str);
					vcad_file_load(tmp2_str);
					gui_hide_group(GROUP_DIRLIST);
				}
			}
			break;
		}
	}
	return 0;
}

int frontend_mdown_save_image(void) {

	// vcad_file_add_lib("/tmp/tt2.vcad");
	// vcad_file_add_hpgl("/tmp/test.plt");
	vcad_file_add_dxf("/tmp/dxf-out.dxf");
// 	vcad_file_add_dxf("/tmp/daemon.dxf");

	return 0;

	char filename[256];
	vcad_select_delete();
	vcad_clean_select();
	strcpy(filename, "/tmp/image.bmp");
	sprintf(gui_info, "Saving Bitmap: %s ...", filename);
	frontend_draw_info(gui_info);

	vcad_mouse_mode = M_NONE;
	vcad_clean_select();
	if (vcad_raster_view == 1) {
		vcad_raster_view = 0;
		vcad_draw();
		vcad_raster_view = 1;
	} else {
		vcad_draw();
	}
	vcad_select_delete();

	SDL_SaveBMP(ECAD_Surface, filename);
	sprintf(gui_info, "Saving Bitmap: %s ...done", filename);
	return 0;
}

int frontend_mdown_cnc_drill(void) {
	return 0;
}

int vcad_xflip(void) {
	int vcad_id;
	int msx = vcad_minsize_x();
	int sx = vcad_size_x() + msx;
	int dx = 0;
	int z1 = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
			dx = ECAD[vcad_id].x2 - ECAD[vcad_id].x1;
			ECAD[vcad_id].x1 = sx - ECAD[vcad_id].x1 - (ECAD[vcad_id].xoff * 2);
			ECAD[vcad_id].x2 = ECAD[vcad_id].x1 + dx;
			if (ECAD[vcad_id].zflipx == 1) {
				z1 = ECAD[vcad_id].z1;
				ECAD[vcad_id].z1 = ECAD[vcad_id].z2;
				ECAD[vcad_id].z2 = z1;
			}
		}
	}
	return 0;
}

int vcad_yflip(void) {
	int vcad_id;
	int msy = vcad_minsize_y();
	int sy = vcad_size_y() + msy;
	int dy = 0;
	int z1 = 0;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
			dy = ECAD[vcad_id].y2 - ECAD[vcad_id].y1;
			ECAD[vcad_id].y1 = sy - ECAD[vcad_id].y1 - (ECAD[vcad_id].yoff * 2);
			ECAD[vcad_id].y2 = ECAD[vcad_id].y1 + dy;
			if (ECAD[vcad_id].zflipy == 1) {
				z1 = ECAD[vcad_id].z1;
				ECAD[vcad_id].z1 = ECAD[vcad_id].z2;
				ECAD[vcad_id].z2 = z1;
			}
		}
	}
	return 0;
}

int vcad_invert(void) {
	int vcad_id;
	for (vcad_id = 0; vcad_id < ECAD_MAX; vcad_id++) {
		if (ECAD[vcad_id].view != 0) {
			ECAD[vcad_id].z1 = 255 - ECAD[vcad_id].z1;
			ECAD[vcad_id].z2 = 255 - ECAD[vcad_id].z2;
		}
	}
	return 0;
}

int vcad_cover(void) {
	vcad_xflip();
	vcad_invert();
	return 0;
}

int frontend_mdown_save(void) {
	char filename[256];
	strcpy(filename, "/tmp/tt.vcad");
	vcad_file_save(filename);
	return 0;
}

int frontend_mdown_new(void) {
	SDL_WM_SetCaption("Volume-CAD", "Volume-CAD");
	vcad_init();
	return 0;
}

int frontend_mdown_load(void) {
	DIR *dir;
	struct dirent *dir_entry;
	char tmp_str[512];
	strcpy(dirlist_str, "");
	strcat(dirlist_str, "..;");
	if ((dir = opendir(directory_path)) != NULL) {
		while ((dir_entry = readdir(dir)) != 0) {
			if (dir_entry->d_name[0] != '.') {
				sprintf(tmp_str, "%s/%s", directory_path, dir_entry->d_name);
				if (frontend_is_directory(tmp_str) == 1) {
					strcat(dirlist_str, dir_entry->d_name);
					strcat(dirlist_str, ";");
				} else if (strstr(tmp_str, ".vcad\0") != 0) {
					strcat(dirlist_str, dir_entry->d_name);
					strcat(dirlist_str, ";");
				}
			}
		}
		closedir(dir);
	}
	gui_update_list(WidgetID[100], dirlist_str, 50, 50, 500, 450, GROUP_DIRLIST, "Verzeichnis");
	gui_show_group(GROUP_DIRLIST);
	return 0;
}

int frontend_mdown_exit(void) {
	gui_running = 0;
	return 0;
}

int frontend_is_directory(char *path) {
        struct stat buf;
        if (stat(path,&buf) != 0) {
                return 0;
        }
        if (S_ISDIR(buf.st_mode) == 1) {
                return 1;
        } else {
                return 0;
        }
}

int frontend_draw_info(char *info_str) {
	gui_update_button(WidgetID[GUI_INFO], info_str);
	gui_draw();
}

int frontend_add_info(void) {
	WidgetID[2] = gui_add_canvas(5, SCREEN_Y - 40, SCREEN_X - 10, 35, GROUP_MAIN, "Info-Frame");
	boxRGBA(Widget[WidgetID[2]].surface, 0, 0, SCREEN_X - 10, 35, 255, 255, 255, 255);
	WidgetID[GUI_INFO] = gui_add_button(" ", 10, SCREEN_Y - 32, SCREEN_X - 220, 20, GROUP_MAIN, "Info-Text");
	WidgetID[GUI_PROGRESS] = gui_add_progress(50, SCREEN_X - 205, SCREEN_Y - 32, 195, 20, GROUP_MAIN, "Progress-Bar");
	return 0;
}

int frontend_add_menu(void) {
	char tmp_str[256];
	int bt_n = 0;
	int bt_diff_x = 27;

	WidgetID[99] = gui_add_canvas(5, 5, SCREEN_X - 10, 30, GROUP_MAIN, "Menu");
	bt_n = 0;
	WidgetID[ICON_NEW]       = gui_add_icon("filenew", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "neue Datei erstellen");
	Widget[WidgetID[ICON_NEW]].mdown = frontend_mdown_new;
	strcpy(Widget[WidgetID[ICON_NEW]].hotkey, "n");
	WidgetID[ICON_LOAD]       = gui_add_icon("fileopen", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Datei als Project(.vcad) ffnen");
	Widget[WidgetID[ICON_LOAD]].mdown = frontend_mdown_load;
	strcpy(Widget[WidgetID[ICON_LOAD]].hotkey, "o");
	WidgetID[ICON_SAVE]       = gui_add_icon("filesave", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Datei als Project(.vcad) speichern");
	Widget[WidgetID[ICON_SAVE]].mdown = frontend_mdown_save;
	strcpy(Widget[WidgetID[ICON_SAVE]].hotkey, "s");
	bt_n++;
	WidgetID[ICON_SAVE_IMG]       = gui_add_icon("image", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Datei als Bitmap(.bmp) speichern");
	Widget[WidgetID[ICON_SAVE_IMG]].mdown = frontend_mdown_save_image;
	strcpy(Widget[WidgetID[ICON_SAVE_IMG]].hotkey, "i");

	bt_n++;
	WidgetID[GRID_SNAP] = gui_add_icon("grid_snap", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "am Raster ausrichten");
	strcpy(Widget[WidgetID[GRID_SNAP]].hotkey, "r");
	Widget[WidgetID[GRID_SNAP]].mdown = vcad_image_raster_snap;
	Widget[WidgetID[GRID_SNAP]].type = 1;
	Widget[WidgetID[GRID_SNAP]].action = 2;
	WidgetID[GRID_VIEW] = gui_add_icon("grid", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Raster anzeigen (Fill-/Line-Mode)");
	strcpy(Widget[WidgetID[GRID_VIEW]].hotkey, "g");
	Widget[WidgetID[GRID_VIEW]].mdown = vcad_image_raster_view;
	Widget[WidgetID[GRID_VIEW]].type = 1;
	Widget[WidgetID[GRID_VIEW]].action = 2;
	bt_n++;
/*	WidgetID[TOGGLE_SHOW_TOP_LABEL] = gui_add_icon("view_top_label", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Top-Label anzeigen");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].hotkey, "l");
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].mdown = vcad_toggle_show_top_label;
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].type = 1;
	Widget[WidgetID[TOGGLE_SHOW_TOP_LABEL]].action = 2;*/
	WidgetID[TOGGLE_SHOW_DRILL] = gui_add_icon("view_drill", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Drill anzeigen");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_DRILL]].hotkey, "d");
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].mdown = vcad_3d_out;
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].type = 1;
	Widget[WidgetID[TOGGLE_SHOW_DRILL]].action = 2;

	bt_n++;
	WidgetID[TOGGLE_SHOW_3D] = gui_add_icon("3d_view", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "3D-Ansicht");
	strcpy(Widget[WidgetID[TOGGLE_SHOW_3D]].hotkey, "m");
	Widget[WidgetID[TOGGLE_SHOW_3D]].mdown = vcad_view_3d;

	bt_n++;
	WidgetID[ICON_SAVE_HM]       = gui_add_icon("point", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Negativ");
	Widget[WidgetID[ICON_SAVE_HM]].mdown = vcad_invert;
	strcpy(Widget[WidgetID[ICON_SAVE_HM]].hotkey, "h");
	WidgetID[ICON_SAVE_HM1]       = gui_add_icon("text", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Spiegeln um die X-Achse");
	Widget[WidgetID[ICON_SAVE_HM1]].mdown = vcad_xflip;
	strcpy(Widget[WidgetID[ICON_SAVE_HM1]].hotkey, "h");
	WidgetID[ICON_SAVE_HM2]       = gui_add_icon("drill", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Spiegeln um die Y-Achse");
	Widget[WidgetID[ICON_SAVE_HM2]].mdown = vcad_yflip;
	strcpy(Widget[WidgetID[ICON_SAVE_HM2]].hotkey, "h");
	WidgetID[TOGGLE_SHOW_BOTTOM_CU] = gui_add_icon("view_bottom_cu", bt_n++ * bt_diff_x + 10, 10, GROUP_MAIN, "Gegenstck erstellen");
	Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].mdown = vcad_cover;
	strcpy(Widget[WidgetID[TOGGLE_SHOW_BOTTOM_CU]].hotkey, "b");

	WidgetID[ICON_EXIT]       = gui_add_icon("exit", SCREEN_X - 10 - bt_diff_x, 10, GROUP_MAIN, "Beenden");
	Widget[WidgetID[ICON_EXIT]].mdown = frontend_mdown_exit;
	strcpy(Widget[WidgetID[ICON_EXIT]].hotkey, "q");

	return 0;
}

int frontend_add_object_list(void) {
	strcpy(dirlist_str, "");
	WidgetID[100] = gui_add_list(dirlist_str, 50, 50, 500, 450, GROUP_DIRLIST, "Verzeichnis");
	Widget[WidgetID[100]].mdown = frontend_mdown_object_list;
	Widget[WidgetID[100]].type = 2;
	Widget[WidgetID[100]].action = 2;
	gui_hide_group(GROUP_DIRLIST);
	return 0;
}

int frontend_add_vcad_menu(void) {
	char tmp_str[256];
	int bt_n = 0;
	int bt_diff_y = 27;
	WidgetID[99] = gui_add_canvas(5, 40, 30, SCREEN_Y - 85, GROUP_TOOLBAR, "Werkzeugleiste");

	WidgetID[DRAW_SELECT] = gui_add_icon("edit", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Entfernen/Neuzeichnen");
	strcpy(Widget[WidgetID[DRAW_SELECT]].hotkey, "e");
	Widget[WidgetID[DRAW_SELECT]].mdown = vcad_select_delete;
	Widget[WidgetID[DRAW_SELECT]].type = 2;

	bt_n++;
	WidgetID[DRAW_BOX] = gui_add_icon("rectangle", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "rechteckige Flche zeichnen");
	strcpy(Widget[WidgetID[DRAW_BOX]].hotkey, "3");
	Widget[WidgetID[DRAW_BOX]].mdown = vcad_select_box;
	vcad_drawit[DRAW_BOX] = vcad_draw_box;
	vcad_mover[DRAW_BOX] = vcad_mover_box;
	vcad_mdown[DRAW_BOX] = vcad_mdown_box;
	vcad_mup[DRAW_BOX] = vcad_mup_box;
	vcad_input[DRAW_BOX] = vcad_input_box;
	Widget[WidgetID[DRAW_BOX]].type = 2;

	WidgetID[DRAW_CIRCLE] = gui_add_icon("circle", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "rechteckigen Rahmen zeichnen");
	strcpy(Widget[WidgetID[DRAW_CIRCLE]].hotkey, "2");
	Widget[WidgetID[DRAW_CIRCLE]].mdown = vcad_select_circle;
	vcad_drawit[DRAW_CIRCLE] = vcad_draw_circle;
	vcad_mover[DRAW_CIRCLE] = vcad_mover_circle;
	vcad_mdown[DRAW_CIRCLE] = vcad_mdown_circle;
	vcad_mup[DRAW_CIRCLE] = vcad_mup_circle;
	vcad_input[DRAW_CIRCLE] = vcad_input_circle;
	Widget[WidgetID[DRAW_CIRCLE]].type = 2;

	bt_n++;
	WidgetID[DRAW_RECGARD] = gui_add_icon("rectangle-filled", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "rechteckige Flche zeichnen");
	strcpy(Widget[WidgetID[DRAW_RECGARD]].hotkey, "4");
	Widget[WidgetID[DRAW_RECGARD]].mdown = vcad_select_recgard;
	vcad_drawit[DRAW_RECGARD] = vcad_draw_recgard;
	vcad_mover[DRAW_RECGARD] = vcad_mover_recgard;
	vcad_mdown[DRAW_RECGARD] = vcad_mdown_recgard;
	vcad_mup[DRAW_RECGARD] = vcad_mup_recgard;
	vcad_input[DRAW_RECGARD] = vcad_input_recgard;
	Widget[WidgetID[DRAW_RECGARD]].type = 2;

	WidgetID[DRAW_CIRCGARD] = gui_add_icon("circle-filled", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "rechteckige Flche zeichnen");
	strcpy(Widget[WidgetID[DRAW_CIRCGARD]].hotkey, "5");
	Widget[WidgetID[DRAW_CIRCGARD]].mdown = vcad_select_circgard;
	vcad_drawit[DRAW_CIRCGARD] = vcad_draw_circgard;
	vcad_mover[DRAW_CIRCGARD] = vcad_mover_circgard;
	vcad_mdown[DRAW_CIRCGARD] = vcad_mdown_circgard;
	vcad_mup[DRAW_CIRCGARD] = vcad_mup_circgard;
	vcad_input[DRAW_CIRCGARD] = vcad_input_circgard;
	Widget[WidgetID[DRAW_CIRCGARD]].type = 2;

	WidgetID[DRAW_RECCIRC] = gui_add_icon("circle", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "liegenden Kreis zeichnen");
	strcpy(Widget[WidgetID[DRAW_RECCIRC]].hotkey, "6");
	Widget[WidgetID[DRAW_RECCIRC]].mdown = vcad_select_reccirc;
	vcad_drawit[DRAW_RECCIRC] = vcad_draw_reccirc;
	vcad_mover[DRAW_RECCIRC] = vcad_mover_reccirc;
	vcad_mdown[DRAW_RECCIRC] = vcad_mdown_reccirc;
	vcad_mup[DRAW_RECCIRC] = vcad_mup_reccirc;
	vcad_input[DRAW_RECCIRC] = vcad_input_reccirc;
	Widget[WidgetID[DRAW_RECCIRC]].type = 2;


	bt_n++;
	WidgetID[DRAW_TEXT] = gui_add_icon("text", 10, bt_n++ * bt_diff_y + 50, GROUP_TOOLBAR, "Text schreiben");
	strcpy(Widget[WidgetID[DRAW_TEXT]].hotkey, "t");
	Widget[WidgetID[DRAW_TEXT]].mdown = vcad_select_text;
	vcad_drawit[DRAW_TEXT] = vcad_draw_text;
	vcad_mover[DRAW_TEXT] = vcad_mover_text;
	vcad_mdown[DRAW_TEXT] = vcad_mdown_text;
	vcad_mup[DRAW_TEXT] = vcad_mup_text;
	vcad_input[DRAW_TEXT] = vcad_input_text;
	Widget[WidgetID[DRAW_TEXT]].type = 2;


	WidgetID[EXPORT_IMAGE] = gui_add_canvas(40, 40, SCREEN_X - 45, SCREEN_Y - 85, GROUP_MAIN, "Zeichenflche");
	Widget[WidgetID[EXPORT_IMAGE]].mover = vcad_image_mover;
	Widget[WidgetID[EXPORT_IMAGE]].mdown = vcad_image_mdown;
	Widget[WidgetID[EXPORT_IMAGE]].mup = vcad_image_mup;

	gui_input = vcad_image_input;

	vcad_init();
	
	Widget[WidgetID[EXPORT_IMAGE]].zoom = 1.0;

	return 0;
}

int frontend_init(void) {
	SDL_WM_SetCaption("Volume-CAD", "Volume-CAD");
	frontend_add_menu();
	frontend_add_info();
	frontend_add_vcad_menu();
	frontend_add_object_list();
	strcpy(directory_path, "/usr/share/doc/vcad/examples");
	cnc_init();

// 	LoadGLTexture("/usr/src/3D-Draw/src/texture.bmp");
// 	glEnable(GL_TEXTURE_2D);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(Widget[WidgetID[EXPORT_IMAGE]].x, Widget[WidgetID[EXPORT_IMAGE]].y, Widget[WidgetID[EXPORT_IMAGE]].w, Widget[WidgetID[EXPORT_IMAGE]].h);
	glOrtho(-100, Widget[WidgetID[EXPORT_IMAGE]].w + 200, -100, Widget[WidgetID[EXPORT_IMAGE]].h + 100, -Widget[WidgetID[EXPORT_IMAGE]].w - 200, Widget[WidgetID[EXPORT_IMAGE]].w + 200);
// 	glFrustum(-100, Widget[WidgetID[EXPORT_IMAGE]].w + 200, -100, Widget[WidgetID[EXPORT_IMAGE]].h + 100, Widget[WidgetID[EXPORT_IMAGE]].w + 200, -Widget[WidgetID[EXPORT_IMAGE]].w - 200);
// 	gluPerspective(45, (Widget[WidgetID[EXPORT_IMAGE]].w / Widget[WidgetID[EXPORT_IMAGE]].h), 1.0, 10000.0);

	glTranslatef(Widget[WidgetID[EXPORT_IMAGE]].w / 2, Widget[WidgetID[EXPORT_IMAGE]].h / 2, 128);
	glRotatef(9.0, 0.0, 1.0, 0.0);
	glRotatef(-4.5, 1.0, 0.0, 0.0);
	glTranslatef(-Widget[WidgetID[EXPORT_IMAGE]].w / 2, -Widget[WidgetID[EXPORT_IMAGE]].h / 2, -128);
	
	return 0;
}
