
int vcad_select_text(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "Text selected");
		vcad_select = SELECT_XY1;
		vcad_mouse_mode = M_DRAW;
		vcad_mode = DRAW_TEXT;
		vcad_clean_select();
		gui_select_icon(WidgetID[DRAW_TEXT]);
	} else if (event.button.button == 4) {
		vcad_textsize++;
		sprintf(gui_info, "Text-Size: %i", vcad_textsize);
	} else if (event.button.button == 5) {
		if (vcad_textsize > 1) {
			vcad_textsize--;
		}
		sprintf(gui_info, "Text-Size: %i", vcad_textsize);
	}
	return 0;
}

int vcad_set_text(int mode, int layer, int x1, int y1, char *text_str, int text_size) {
	ECAD[vcad_active_id].type = DRAW_TEXT;
	ECAD[vcad_active_id].x1 = x1;
	ECAD[vcad_active_id].y1 = y1;
	ECAD[vcad_active_id].x2 = x1;
	ECAD[vcad_active_id].y2 = y1;
	ECAD[vcad_active_id].size = text_size;
	ECAD[vcad_active_id].dtype = vcad_padtype;
	ECAD[vcad_active_id].rotate = 0;
	ECAD[vcad_active_id].mode = mode;
	ECAD[vcad_active_id].view = 1;
	ECAD[vcad_active_id].layer = vcad_active_layer;
	ECAD[vcad_active_id].text[0] = 0;
	strcpy(ECAD[vcad_active_id].text, text_str);
	sprintf(ECAD[vcad_active_id].info, "Text (%s)", text_str);
	return 0;
}

int vcad_draw_text(int vcad_id) {
	SDL_Rect dstrect;
	SDL_Surface *text_img = NULL;
	SDL_Color color;
	if (vcad_mouse_mode == M_DRAW && vcad_id == vcad_active_id) {
		boxRGBA(ECAD_Surface, vcad_zoom_int(ECAD[vcad_id].x1 - 2), vcad_zoom_int(ECAD[vcad_id].y1 + 2), vcad_zoom_int(ECAD[vcad_id].x1 + (ECAD[vcad_id].size * 10) + 4), vcad_zoom_int(ECAD[vcad_id].y1 + ECAD[vcad_id].size + 4), 228, 228, 228, 255);
	}
	if (vcad_show_top_label == 1) {
		color.r = tl_r;
		color.g = tl_g;
		color.b = tl_b;
		if ((text_img = TTF_RenderText_Solid(Stat_Font, ECAD[vcad_id].text, color)) != NULL) {
			dstrect.x = vcad_zoom_int(ECAD[vcad_id].x1);
			dstrect.y = vcad_zoom_int(ECAD[vcad_id].y1);
			dstrect.w = text_img->w;
			dstrect.h = text_img->h;
			SDL_BlitSurface(text_img, NULL, ECAD_Surface, &dstrect);
			SDL_FreeSurface(text_img);
		}
	}
	return 0;
}

int vcad_mdown_text(void) {
	if (event.button.button == 1) {
		if (vcad_select == SELECT_XY1) {
			vcad_x1 = event.button.x;
			vcad_y1 = event.button.y;
			vcad_x2 = vcad_x1;
			vcad_y2 = vcad_y1;
			vcad_set_text(0, vcad_active_layer, vcad_x1, vcad_y1, "", vcad_textsize);
		}
	}
	return 0;
}

int vcad_mup_text(void) {
	if (event.button.button == 1) {
		if (vcad_select == SELECT_XY1) {
			vcad_x1 = event.button.x;
			vcad_y1 = event.button.y;
			vcad_x2 = vcad_x1;
			vcad_y2 = vcad_y1;
			vcad_select = SELECT_TEXT;
			vcad_set_text(0, vcad_active_layer, vcad_x1, vcad_y1, "", vcad_textsize);
		}
	}
	return 0;
}

int vcad_mover_text(void) {
	if (vcad_select == SELECT_XY1) {
		vcad_x1 = event.button.x;
		vcad_y1 = event.button.y;
		vcad_x2 = vcad_x1;
		vcad_y2 = vcad_y1;
		sprintf(gui_info, "Text-Possition: x=%0.1fmm, y=%0.1fmm", (float)vcad_x1 / 10.0, (float)vcad_y1 / 10.0);
		vcad_set_text(0, vcad_active_layer, vcad_x1, vcad_y1, "", vcad_textsize);
	}
	return 0;
}

int vcad_input_text(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		if (vcad_select == SELECT_XY1) {
			char *loc;
			fprintf(stderr, "%s\n", tmp_str);
			if ((loc = strstr(tmp_str, ",")) != 0) {
				vcad_x1 = atoi(tmp_str);
				vcad_y1 = atoi(loc + 1);
				vcad_x2 = vcad_x1;
				vcad_y2 = vcad_y1;
				vcad_select = SELECT_TEXT;
				vcad_set_text(0, vcad_active_layer, vcad_x1, vcad_y1, "", vcad_textsize);
			}
		} else if (vcad_select == SELECT_TEXT) {
			vcad_select = SELECT_XY1;
			vcad_set_text(1, vcad_active_layer, vcad_x1, vcad_y1, tmp_str, vcad_textsize);
			vcad_active_id = vcad_get_free_id();
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	if (vcad_select == SELECT_XY1) {
		sprintf(gui_info, "Text-Possition: x=?, y=? (%s)", tmp_str);
	} else if (vcad_select == SELECT_TEXT) {
		vcad_set_text(0, vcad_active_layer, vcad_x1, vcad_y1, tmp_str, vcad_textsize);
		sprintf(gui_info, "Text-String: x=%i, y=%i (%s)", vcad_x1, vcad_y1, tmp_str);
	}
	return 0;
}


